                                       Lappeenranta, May 7, 1993

Welcome to the user group of RIETVELD/HARMONICS.

The source program is written in standard FORTRAN 77 form arranged
in 25 separate blocks according to the different operations to be 
performed. For instance, the program Y.FOR calculates the values of 
harmonic functions, TEXTUR.FOR picks the right harmonic functions for 
the space group and so on.

The executiveable program can be generated by compiling and linking
the main program REFINEMENT.FOR in usual way. This operation unifies
all the separate parts into the binary file REFINEMENT.EXE.

The text file INFO.TXT begins with a short history of this program.
There are lists of variables, parameters and some default values, the IO
units are also described. The structure and format of input and output 
data are explained in the text file GUIDE.TXT.

There is two different type of example data file pairs: MG100.MES, MG100.PAR
and OLIVIN.MES, OLIVIN.PAR. MG100 data is from a real measurement and OLIVIN
data is a simulated version. The *.MES files consist of rough intesity data
and background information and are used for preparing data for refinement.
The *.PAR files contain all the structure information and controll codes
needed in refinement process. The refinement can be performed with these 
data by using the command @GO MG100 or @GO OLIVIN, and the results will come
into the file OUT.DAT.

In the present package there is no graphics, but in advance, I hope,
the program will be developed and the graphics will be added. 
I would be happy if you could inform me about mistakes and shortcomings 
of this version. I would also appreciate very much your note of 
application and would be grateful to hear about your experiences. 
My email address is Matti.Jarvinen@lut.fi.

Matti Jarvinen
Lappeenranta University of Technology
P.O.Box 20, SF-53851 LPR
FINLAND

*     ***************
      SUBROUTINE ITER
*     ***************
*
      INTEGER OFFSET
      PARAMETER (OFFSET = 2**16)

      LOGICAL VERT
      CHARACTER ATEXT*4,TEXT*80
      COMPLEX CWERF,VALUE,Z
      INTEGER I1(3),ICALC(10),IOBS(10)
      REAL DUMP(999),SOMEGA(999),DERIV(51)
      INCLUDE 'COMMONS.FOR'
      COMMON/CHARS/ATEXT(30),TEXT
      COMMON/DERMAT/DERSTO(999,51)
      COMMON/DATA/CUT,NREFL,NH(3),IALFA,ISTAP,NCHAN,ICODE(999),
     *       HKL(3,999),SJJ(999),YOBS(15000),WEIGHT(15000),IORD(15000)
      COMMON/PARAMS/AINSTR(10),ACRYST(22), ATOM(14,30),
     *              LINSTR(10),LCRYST(22),LATOM(14,30),
     *              PINSTR(10),PCRYST(22),PATOM(14,30)
      COMMON/IO/EPS,RELAX,RELAXB,RELAXC,SUMOBS,SUMW,SUMWBS,SW,IPONS,
     *          LMAT,LOUT,NUM
      SAVE
      DATA SQRPI/1.7724538509/,CONST/11459.155903/,SKEW/0.0/
      DATA SQRLN2/0.832554611158/,GAUSS/0.9394372787/
*
      WRITE(6,1000)
      WRITE(6,1001) ICYCLE
      IF(FORCED) WRITE(6,1002)
      SUMW=0
      SUMCAL=0
      SUMDIF=0
      SUMFOB=0
      SUMDFF=0
      FNUCDI=0
      FNUCOB=0
      FMAGDI=0
      FMAGOB=0
      DO 10 I=1,MAXS+MAXCON
      V(I)=0
      DO 10 J=1,MAXS+MAXCON
   10 SMM(I,J)=0
      YES=(IPONS.EQ.2.OR.IPONS.EQ.3).AND.ICYCLE.EQ.NCYCLE
      TYPE=(LOUT.EQ.1).AND.(ICYCLE.EQ.NCYCLE)
      PUNCH=((IPONS.EQ.1).OR.(IPONS.EQ.3)).AND.(ICYCLE.EQ.NCYCLE)
      DO 20 I=1,NREFL
      IF(.NOT.STEADY) CALL COORD(HKL(1,I),I)
      SOMEGA(I)=0
      FESD(I)=0
   20 FOBS(I)=0
      IF(.NOT.STEADY) CALL PROFIL
      IF(YES) THEN
         OPEN(UNIT=13,STATUS='NEW',FORM='FORMATTED'
     *        ,CARRIAGECONTROL='LIST'                         ! VAX/VMS
     *        )
         WRITE(13,1003) TEXT
         WRITE(13,1004) 0.01*(IALFA-PINSTR(9)),0.01*ISTAP,NCHAN
      END IF
      IF(TYPE) THEN
         IOMEG=IALFA+(NCHAN-1)*ISTAP
         WRITE(6,1005) IALFA,IOMEG,ISTAP
      END IF
      CALL CALCUL
      NO=0
      DO 110 M=1,NCHAN
      ISS=IALFA+(M-1)*ISTAP
      YCALC=0
      IF(ABS(YOBS(M)).LT.0.001) GO TO 100
      DO 40 J=1,MAXS
   40 DERIV(J)=0
*
*     Calculate the contribution of the reflections ORD1 to ORD2 to the
*     derivatives w.r.t. the profile intensity YOBS.
*
      IORD1=MOD(IORD(M),OFFSET)
      IORD2=IORD(M)/OFFSET
      DO 70 J=IORD1,IORD2
      VERT=BRAGG(J).LE.LIM
      TANTH=TAN(BRAGG(J)/CONST)
      DELTA=ISS-BRAGG(J)-PINSTR(9)-PINSTR(10)/TANTH
      DELT=DELTA*DELTA
      CORR=1
      COS2TH=1/(1+TANTH**2)
      SINTH=TANTH*SQRT(COS2TH)
      IF(VERT) THEN
         ASYMM=DELT*SIGN(1.,DELTA)
         CORR=1-PINSTR(1)*ASYMM/TANTH
         IF(CORR.LE.0) CORR=0.0001
      END IF
*
*     Explanation:
*        GHALF  = Gaussian halfwidth 2w(g)
*        BETAG  = Gaussian integral breadth = GHALF/0.9394372787...
*        Y      = Complex part of Voigt function argument
*        DLNDTH = Derivative of LOG(BETAG) with respect to Bragg angle
*        DYDTH  = Derivative of y with respect to Bragg angle
*
*     Function EXPERF(Y) evaluates EXP(Y**2) * ERFC(Y).
*
      GHALF=SQRT(PINSTR(3)/TANTH**2+TANTH*(PINSTR(4)*TANTH+PINSTR(5))+
     *           PINSTR(6))
      Y=SQRLN2*(PINSTR(7)*TANTH+PINSTR(8)/SQRT(COS2TH))/GHALF
      DLNDTH=(-PINSTR(3)/TANTH**3+PINSTR(4)*TANTH+PINSTR(5)/2)
     *       /(COS2TH*GHALF**2)
      DYDTH=SQRLN2*(PINSTR(7)+PINSTR(8)*SINTH)/(GHALF*COS2TH)-Y*DLNDTH
      X=SQRPI*GAUSS*DELTA/GHALF
      Z=CMPLX(X,Y)
*
*     Voigtian profile shape function - Gautschi algorithm CWERF.
*
      VALUE=SJJ(J)*CORR*GAUSS*CWERF(Z)/GHALF
      OMEGA=REAL(VALUE)
      SOMEGA(J)=SOMEGA(J)+OMEGA
      DUMP(J)=OMEGA*(FNUC(J)+FMAG(J))
      YCALC=YCALC+DUMP(J)
      TERM1=X*OMEGA-Y*AIMAG(VALUE)
      TERM2=X*AIMAG(VALUE)+Y*OMEGA-SJJ(J)*CORR*GAUSS/(SQRPI*GHALF)
*
*     DER = OMEGA for those parameters that are not part of the
*     argument of the profile shape function.
*
      DO 70 K=1,MAXS
      DER=OMEGA
*
*     Cell constant derivatives. Note that CONST includes value 2
*     and thus CONST may not be multiplied with it any more.
*     Note also that zeropoint angle dependence affects this term.
*
      DO 60 L=1,6
      IF(LCRYST(L).EQ.K) THEN
         DER=2*TERM1*(CONST*SQRPI*GAUSS*(1+PINSTR(10)*(1+TANTH**2)/2)
     *       /GHALF-X*DLNDTH)+2*TERM2*DYDTH-OMEGA*DLNDTH
         GO TO 70
      END IF
   60 CONTINUE
*
*     Gaussian halfwidth parameter derivatives.
*
      IF(LINSTR(3).EQ.K.OR.LINSTR(4).EQ.K.OR.LINSTR(5).EQ.K.OR.
     *   LINSTR(6).EQ.K) THEN
         DER=(2*X*X-2*Y*Y-1)*OMEGA-4*X*Y*AIMAG(VALUE)+
     *        2*Y*SJJ(J)*CORR*GAUSS/(SQRPI*GHALF)
*
*     Lorentzian halfwidth parameter derivatives.
*
      ELSE IF(LINSTR(7).EQ.K.OR.LINSTR(8).EQ.K) THEN
         DER=2*TERM2
*
*     Zeropoint derivative - constant part.
*
      ELSE IF(LINSTR(9).EQ.K) THEN
         IF(VERT) THEN
            HALF=GHALF*APPROX(Y)/EXPERF(Y)
            X1=PINSTR(1)*SIGN(1.0,DELTA)*HALF**2/CORR
         ELSE
            X1=0
         END IF
         DER=2*(1+X1)*TERM1
*
*     Zeropoint derivative - cotangent part.
*
      ELSE IF(LINSTR(10).EQ.K) THEN
         IF(VERT) THEN
            HALF=GHALF*APPROX(Y)/EXPERF(Y)
            X1=PINSTR(1)*SIGN(1.0,DELTA)*HALF**2/CORR
         ELSE
            X1=0
         END IF
         DER=2*(1+X1)*TERM1/TANTH
*
*                                  Asymmetry parameter derivative.
*
      ELSE IF(LINSTR(1).EQ.K.AND.VERT) THEN
         DER=ASYMM*OMEGA/CORR
      END IF
*
   70 DERIV(K)=DERSTO(J,K)*DER+DERIV(K)
*
*     Form sums.
*
      YCALC=YCALC/SCALE
      DELTA=YOBS(M)-YCALC
      IF(YCALC.NE.0) THEN
         DO 80 J=IORD1,IORD2
         X=DUMP(J)/YCALC
         IF(TYPE) FESD(J)=X*X/WEIGHT(M)+FESD(J)
   80    FOBS(J)=FOBS(J)+X*YOBS(M)
         SUMCAL=SUMCAL+YCALC
      END IF
      SUMW=SUMW+WEIGHT(M)*DELTA*DELTA
      SUMDIF=SUMDIF+ABS(DELTA)
      DELTA=DELTA*SCALE
*
*     Sum normal matrix elements and vector.
*
      DO 90 J=1,MAXS
      X=WEIGHT(M)*DERIV(J)
      V(J)=V(J)+DELTA*X
      DO 90 K=J,MAXS
   90 SMM(J,K)=SMM(J,K)+X*DERIV(K)
  100 IF(.NOT.(YES.OR.TYPE)) GO TO 110
      NO=NO+1
      ICALC(NO)=YCALC+0.5
      IOBS(NO)=NINT(YOBS(M))
      IF(NO.NE.10.AND.M.LT.NCHAN) GO TO 110
*
*     Print (TYPE=TRUE) and punch (YES=TRUE) calculated and observed
*     profile intensities.
*
      IF(TYPE) WRITE(6,1006) ISS-(NO-1)*ISTAP,(IOBS(J),ICALC(J),J=1,NO)
      IF(YES) WRITE(13,1007) (IOBS(J),J=1,NO)
      IF(YES) WRITE(13,1007) (ICALC(J),J=1,NO)
      NO=0
  110 CONTINUE
      IF(YES) WRITE(13,1008)
      DO 120 I=1,NREFL
      IF(FOBS(I).LE.0) THEN
         FOBS(I)=0
         FESD(I)=0
      END IF
      BB=SJJ(I)/(ISTAP*SCALE)
      IF(TYPE) FESD(I)=BB*SQRT(FESD(I)*250)/SOMEGA(I)
      FNUC(I)=FNUC(I)*BB
      FMAG(I)=FMAG(I)*BB
  120 FOBS(I)=FOBS(I)*BB/SOMEGA(I)
*
*     Update all variables and print the data.
*
      CALL UPDATE(SKEW)
*
*     On last cycle all selected data is printed.
*
      IF(.NOT.TYPE) GO TO 170
      WRITE(6,1009)
      WRITE(6,1011) NH
      DO 160 I=1,NREFL
      K=FNUC(I)+FMAG(I)+0.5
      L=NINT(FOBS(I)-K)
      TANTH=TAN(BRAGG(I)/CONST)
      M=BRAGG(I)+PINSTR(9)+PINSTR(10)/TANTH+0.5
      DO 130 J=1,3
  130 I1(J)=NINT(HKL(J,I)*NH(J))
      INUC=FNUC(I)+0.5
      IMAG=FMAG(I)+0.5
      KOBS=NINT(FOBS(I))
      IESD=FESD(I)+0.5
      GHALF=SQRT(PINSTR(3)/TANTH**2+TANTH*(PINSTR(4)*TANTH+PINSTR(5))+
     *           PINSTR(6))
      CAUCHY=PINSTR(7)*TANTH+PINSTR(8)*SQRT(1+TANTH**2)
      Y=SQRLN2*CAUCHY/GHALF
      TOTAL=GHALF*APPROX(Y)/EXPERF(Y)
      WRITE(6,1011) I1,M,INUC,IMAG,K,KOBS,L,IESD,TEXCOR(I),GHALF,CAUCHY,
     *              TOTAL,Y
  160 CONTINUE
  170 DO 180 I=1,NREFL
      IF(FOBS(I).EQ.0.AND.FNUC(I)+FMAG(I).EQ.0) GO TO 180
      SUMDFF=SUMDFF+ABS(FOBS(I)-ABS(FNUC(I)+FMAG(I)))
      SUMFOB=SUMFOB+FOBS(I)
      X=FOBS(I)/(FNUC(I)+FMAG(I))
      FNUCDI=FNUCDI+ABS(FNUC(I)-FNUC(I)*X)
      FNUCOB=FNUCOB+FNUC(I)*X
      FMAGDI=FMAGDI+ABS(FMAG(I)-FMAG(I)*X)
      FMAGOB=FMAGOB+FMAG(I)*X
  180 CONTINUE
*
*     Calculate and print sums.
*
      WRITE(6,1012) 100*SUMDFF/SUMFOB,100*SUMDIF/SUMOBS,
     *              100*SQRT(SUMW/SUMWBS)
      WRITE(6,1013) 100*SQRT(250*(NUM-MAXS+MAXCON)/SUMWBS)
      WRITE(6,1014) 100*FNUCDI/FNUCOB
      IF(HALPER.OR.UNIAX.OR.CUBIC) WRITE(6,1015) 100*FMAGDI/FMAGOB
      I=NUM-MAXS+MAXCON
      WRITE(6,1016) I
      WRITE(6,1017) SUMDIF,SUMOBS,SUMCAL,SUMWBS/250,SUMDFF,SUMFOB,
     *              FNUCDI,FNUCOB,FMAGDI,FMAGOB,SUMW/(250*I),SKEW
*
      CALL TIMES(1)
      RETURN
 1000 FORMAT('0',128('+'))
 1001 FORMAT(/,'0CYCLE NUMBER',I3)
 1002 FORMAT(' *FORCED TERMINATION*')
 1003 FORMAT(A80)
 1004 FORMAT(2F10.4,I10)
 1005 FORMAT('0DIAGRAM IS FROM',I6,' TO',I6,' IN STEPS OF',I3,
     *       ' *1/100THS DEGREE',//,' POSITION',10(' YOBS YCALC '))
 1006 FORMAT(1X,21I6)
 1007 FORMAT(10I8)
 1008 FORMAT(3X,'-1000',/,'  -10000')
 1009 FORMAT(/,28X,'I N T E N S I T I E S',39X,'H A L F W I D T H S',/,
     *   '   H  K  L  POSITION  NUCLEAR MAGNETIC   TOTAL  OBSERVED DI',
     *   'FFERENCE  ESD  TEXTURE  GAUSSIAN LORENTZIAN   TOTAL',8X,'Y')
 1011 FORMAT(1X,3I3,I8,I10,3I9,I10,I7,F9.5,4F10.4)
 1012 FORMAT('0R-FACTORS=',3F8.2)
 1013 FORMAT(' EXPECTED =',8X,F8.2)
 1014 FORMAT('0R-FACTOR(NUCLEAR) =',F7.2)
 1015 FORMAT(' R-FACTOR(MAGNETIC)=',F7.2)
 1016 FORMAT('0N-P+C=',I8)
 1017 FORMAT(/,7X,'SUMYDIF',7X,'SUMYOBS',6X,'SUMYCALC',6X,'SUMWYOBSSQ',
     1       5X,'SUMIDIF',7X,'SUMIOBS',/,1X,6E14.4,//,6X,'SUMNUCDIF',5X,
     2       'SUMNUCOBS',5X,'SUMMAGDIF',5X,'SUMMAGOBS',6X,'RESIDUAL',4X,
     3       'LG(SKEWNESS)',/,1X,5E14.4,F16.8,/)
      END

      COMPLEX FUNCTION CERF(Z)
      COMPLEX Z
*
*     This program calculates the real and the imaginary part of
*     function
*
*        w(z) = Exp(-z*z) * Erfc(z),
*
*     that is, the complex error function, using a series expansion
*     in terms of the imaginary argument.
*
*     Subroutine referenced: FUNCTION DAWSON, for Dawson's integral.
*
      COMPLEX VALUE
      REAL DU,DV,X,YI,SU,SV,U,V,U0,V0,U1,V1,DAWSON,SQRPI,CUT
      INTEGER I
      DATA SQRPI/1.772453851/,CUT/5.0E-9/
*
      X=REAL(Z)
      U0=SQRPI*EXP(-X*X)
      V0=2*DAWSON(X)
      U1=-2*X*U0 
      V1=2*(1-X*V0)
      I=1
      YI=1
      VALUE=CMPLX(U0,V0)
      SU=1
      SV=1
10    SU=-SU
      U=SU*V1
      V=SV*U1
20    YI=YI*AIMAG(Z)/I
      DU=U*YI
      DV=V*YI
      IF(ABS(DU) .LE. CUT .AND. ABS(DV) .LE. CUT) GO TO 30
      VALUE=VALUE+CMPLX(DU,DV)
      U=U1
      U1=-2*(I*U0+X*U1)
      U0=U
      V=V1
      V1=-2*(I*V0+X*V1)
      V0=V
      I=I+1
      IF(MOD(I,2) .NE. 0) GO TO 10
      SV=-SV
      U=SU*U1
      V=SV*V1
      IF(I .LE. 30) GO TO 20
*
30    CERF=VALUE/SQRPI
      RETURN
      END

*     *****************************
      SUBROUTINE GROUP(ANGLE,XRAYS)
*     *****************************
*
      REAL ANGLE
      LOGICAL XRAYS
*
*     This subroutine reads the space group number (and for
*     orthorhombic case, the unique axis specification) and
*     chooses spherical harmonic functions affecting in
*     specified symmetry case.
*     The incident angle defining measurement geometry is read and
*     the radiation is specified.
*
      CHARACTER AXIS*1,TEXT*3,RAYS*1,SOURCE*7
      REAL FLAG(1)
      INTEGER IFLAG(1)
      COMMON/SPACE/JUMP,A,B,C,COSALF,COSBET,COSGAM,SINALF,SINBET,SINGAM
*
*     Take three non-blank characters from the next input line.
*
      AXIS=' '
      CALL READER(5,TEXT,3,FLAG,0,IFLAG,0,.TRUE.)
*
*     Is it a pure number?
*
      READ(TEXT,'(BN,I3)',ERR=10) IGROUP
*
*     Yes, it is.
*
      IF(IGROUP .LE. 0 .OR. IGROUP .GT. 230) GO TO 30
*
*                                    Triclinic
      IF(IGROUP .LE. 2) THEN
         JUMP=1
         WRITE(6,1000) 'triclinic',IGROUP
*                                    Monoclinic
      ELSE IF(IGROUP .LE.  15) THEN
         JUMP=2
         WRITE(6,1000) 'monoclinic',IGROUP
*
*     Orthorhombic case but unique axis choise was not given.
*     JUMP cannot be set.
*
      ELSE IF(IGROUP .LE.  74) THEN
      GO TO 40
*                                    Tetragonal case 1
      ELSE IF(IGROUP .LE.  88) THEN
         JUMP=6
         WRITE(6,1000) 'tetragonal',IGROUP
*                                    Tetragonal case 2
      ELSE IF(IGROUP .LE. 142) THEN
         JUMP=7
         WRITE(6,1000) 'tetragonal',IGROUP
*                                    Trigonal case 1
      ELSE IF(IGROUP .LE. 148) THEN
         JUMP=8
         WRITE(6,1000) 'trigonal',IGROUP
*                                    Trigonal case 2
      ELSE IF(IGROUP .LE. 167) THEN
         JUMP=9
         WRITE(6,1000) 'trigonal',IGROUP
*                                    Hexagonal case 1
      ELSE IF(IGROUP .LE. 176) THEN
         JUMP=10
         WRITE(6,1000) 'hexagonal',IGROUP
*                                    Hexagonal case 2
      ELSE IF(IGROUP .LE. 194) THEN
         JUMP=11
         WRITE(6,1000) 'hexagonal',IGROUP
*                                    Cubic case 1
      ELSE IF(IGROUP .LE. 206) THEN
         JUMP=12
         WRITE(6,1000) 'cubic',IGROUP
*                                    Cubic case 2
      ELSE
         JUMP=13
         WRITE(6,1000) 'cubic',IGROUP
      END IF
*
      GO TO 20
*
*     It is not a pure number - find unique axis specification.
*
   10 READ(TEXT,'(I2,A1)',ERR=40) IGROUP,AXIS
      IF(IGROUP .LT. 16 .OR. IGROUP .GT. 74) GO TO 40
*
*     Orthorombic space group found.
*     Is the character A, B or C?
*
      I  =  INDEX(AXIS,'A') + INDEX(AXIS,'a')
     * + 2*(INDEX(AXIS,'B') + INDEX(AXIS,'b'))
     * + 3*(INDEX(AXIS,'C') + INDEX(AXIS,'c'))
      IF(I .EQ. 0) GO TO 40
*
*     It is.
*
      JUMP=I+2
      WRITE(6,1001) IGROUP,AXIS
*
*     Now incident angle and radiation type.
*
   20 CALL READER(5,RAYS,0,FLAG,1,IFLAG,0,.FALSE.)
      CALL READER(5,RAYS,1,FLAG,0,IFLAG,0,.FALSE.)
      ANGLE=FLAG(1)
      IF(ABS(ANGLE) .GT. 90) THEN
         WRITE(6,1002) ANGLE
         ANGLE=0
      END IF
      IF(RAYS.EQ.'X'.OR.RAYS.EQ.'x') THEN
         XRAYS=.TRUE.
         SOURCE='X - ray'
      ELSE IF(RAYS.EQ.'N'.OR.RAYS.EQ.'n') THEN
         XRAYS=.FALSE.
         SOURCE='Neutron'
      ELSE
         WRITE(6,1003)
         STOP
      END IF
      WRITE(6,1004) SOURCE,ANGLE

      RETURN
*                               Error: Space group beyond limit.
   30 WRITE(6,1005) IGROUP
      GO TO 50
*                               Error: Incorrect information was given
*                                      for orthorombic case.
   40 WRITE(6,1006) IGROUP,AXIS
   50 STOP
 1000 FORMAT('0The symmetry is ',A,'. Space group =',I4,'.',/)
 1001 FORMAT('0The symmetry is orthorhombic. Space group =',I4,
     *       '. Unique axis = ',A1,'.',/)
 1002 FORMAT(' Invalid incident angle =',F6.1,'. Zero assumed.')
 1003 FORMAT(' No radiation specified. Give a word starting with',
     *       ' X for X-rays or N for neutrons on line 2.')
 1004 FORMAT(/,1X,A,' radiation is used with incident angle',F6.1,
     *       ' degrees.',/)
 1005 FORMAT(' In GROUP: Space group',I5,' is beyond limits.')
 1006 FORMAT(' In GROUP: Space group for orthorhombic case =',I4,
     *       '. Unique axis = ',A1,'. Either of them is invalid.')
      END

*     ************************
      SUBROUTINE GEOMET(ANGLE)
*     ************************
      REAL ANGLE
*
*     This subroutine uses the incident angle to scale the texture
*     coefficients to be independent on measurement geometry.
*
      INCLUDE 'BLANK.FOR'
      COMMON/DATA/CUT,NREFL,NH(3),IALFA,ISTAP,NCHAN,ICODE(999),
     *       HKL(3,999),SJJ(999),YOBS(15000),WEIGHT(15000),IORD(15000)
      DATA CONST/11459.155903/,RAD/1.7453292520E-2/
*
      DO 10 I=1,NREFL
*                                  Reflection geometry     - alpha =  0
      IF(ANGLE .EQ. 0) THEN
         GEOM(I)=1
*                                  Transmission geometry and
*                                  Debye-Scherrer geometry - alpha = 90
      ELSE IF(ANGLE .EQ. 90) THEN
         GEOM(I)=0
*                                  Guinier geometries -
*                                  alpha = theta - incident angle
      ELSE
         GEOM(I)=COS(BRAGG(I)/CONST+RAD*ANGLE)
      END IF
   10 CONTINUE
      RETURN
      END

*     *****************************
      FUNCTION Y(L,N,COSTHE,COSPHI)
*     *****************************
      INTEGER L,N
      REAL COSTHE,COSPHI,Y
*
*     This subroutine evaluates spherical harmonic functions
*
*     Y   (theta,phi),   where m=ABS(N) and s is sign of N.
*      lms
*
      INTEGER M
      REAL SINTHE
*
      M=ABS(N)
      SINTHE=SQRT(1-COSTHE**2)
*
*     First operate with l only - branch according to it.
*     Odd values of l are invalid for powder neutron diffraction.
*
      GO TO (900,20,900,40,900,60,900,80),L
      GO TO 900
*                             l = 2
   20 IF(M .EQ. 0) THEN
         YL=(3*COSTHE**2-1)/2
      ELSE IF(M .EQ. 1) THEN
         YL=2*COSTHE*SINTHE
      ELSE
         YL=SINTHE**2
      END IF
      GO TO 100
*                             l = 4
   40 IF(M .EQ. 0) THEN
         YL=(COSTHE**2*(35*COSTHE**2-30)+3)/8
      ELSE IF(M. EQ. 1) THEN
         YL=0.94695*(7*COSTHE**2-3)*COSTHE*SINTHE
      ELSE IF(M .EQ. 2) THEN
         YL=7*(7*COSTHE**2-1)*SINTHE**2/9
      ELSE IF(M .EQ. 3) THEN
         YL=3.079201436*COSTHE*SINTHE**3
      ELSE
         YL=SINTHE**4
      END IF
      GO TO 100
*                             l = 6
   60 IF(M .EQ. 0) THEN
         YL=(((231*COSTHE**2-315)*COSTHE**2+105)*COSTHE**2-5)/16
      ELSE IF(M .EQ. 1) THEN
         GO TO 900
      ELSE IF(M .EQ. 2) THEN
         YL=0.64549*((33*COSTHE**2-18)*COSTHE**2+1)*SINTHE**2
      ELSE IF(M .EQ. 3) THEN
         YL=1.41685*(11*COSTHE**2-3)*COSTHE*SINTHE**3
      ELSE IF(M .EQ. 4) THEN
         YL=0.81675*(11*COSTHE**2-1)*SINTHE**4
      ELSE IF(M .EQ. 5) THEN
         GO TO 900
      ELSE
         YL=SINTHE**6
      END IF
*                             l = 8
      GO TO 100
   80 IF(M .EQ. 0) THEN
         YL=((((6435*COSTHE**2-12012)*COSTHE**2+6930)*COSTHE**2-1260)*
     *          COSTHE**2+35)/128
      ELSE
         GO TO 900
      END IF
*
*     Now m, that is, phi-dependence is added.
*
  100 IF(N .GT. 0) THEN
         Y=YL*COS(M*ACOS(COSPHI))
      ELSE IF(N .LT. 0) THEN
         Y=YL*SIN(M*ACOS(COSPHI))
      ELSE
         Y=YL
      END IF
*
      RETURN
*
*     Error: L is illegal.
*
  900 WRITE(6,1000) L,M
      STOP
 1000 FORMAT(' In Y: Invalid indices; L =',I3,' M =',I3,'.')
      END

*     *****************
      SUBROUTINE PREPAR
*     *****************
******************************************************
*     This program prepares the profile data.        *
******************************************************

      INTEGER OFFSET
      PARAMETER (OFFSET = 2**16)

      CHARACTER TEXT*80,STAR*1
      LOGICAL MARK
      REAL BAK(100),HW(999),PLOR(999),POS(100),TL(999),T(999),HWOUT(3),
     1     TOUT(3),HKL,SJJ,YOBS,WEIGHT
      INTEGER IOUT(3),ICOUT(3),IHOUT(3,3),ICODE,IH(3,999),IHIGH(10),
     1     INDEX(999),LOW(10),LL(999),NH,M(999),MOUT(3),JCODE(999),IORD
      INCLUDE 'BLANK.FOR'
      COMMON/DATA/CUT,NREFL,NH(3),IALFA,ISTAP,NCHAN,ICODE(999),
     *       HKL(3,999),SJJ(999),YOBS(15000),WEIGHT(15000),IORD(15000)
      COMMON/PARAMS/AINSTR(10),ACRYST(22), ATOM(14,30),
     *              LINSTR(10),LCRYST(22),LATOM(14,30),
     *              PINSTR(10),PCRYST(22),PATOM(14,30)
      COMMON/SPACE/JUMP,A,B,C,COSALF,COSBET,COSGAM,SINALF,SINBET,SINGAM

      DATA SQRLN2/0.83255461116/
      DATA STAR/'*'/
*
*     When angles in 1/10000 cycles, following statement should read:
*     DATA CONST/3183.0988618/  i. e. CONST = 10000/3.141592658...
      DATA CONST/11459.155903/
*                                 Now CONST = 36000/3.141592658...
*     Read and print title.
*
      OPEN(UNIT=3,STATUS='OLD',FORM='FORMATTED'
     *           ,READONLY                          ! VAX/VMS
     *                    )
      OPEN(UNIT=7,STATUS='NEW',FORM='FORMATTED')
      WRITE(7,1000)
      READ(3,'(A)') TEXT
      WRITE(7,'(1X,A)') TEXT
*
      CALL READER(3,TEXT,0,POS,3,IOUT,0,.TRUE.)
      CTHM=POS(1)
      POLAR=POS(2)
      CUT=POS(3)
*
*     Set default value for cut.
*
      IF(CUT.LE.0.OR.CUT.GT.100) CUT=5
      WRITE(7,1001) 2*SQRT(SLABDA)
      WRITE(7,1002)
      WRITE(7,1003) (PINSTR(I),I=3,8)
      WRITE(7,1004) (PINSTR(I),I=9,10)
      WRITE(7,1005) CTHM,POLAR,CUT
*
*     Read in background.
*
      I=1
   10 CALL READER(3,TEXT,0,TOUT,2,IOUT,0,.TRUE.)
      POS(I)=TOUT(1)
      BAK(I)=TOUT(2)
      IF(POS(I).GT.-99) THEN
         I=I+1
         GO TO 10
      END IF
      NB=I-1
      WRITE(7,1006)
      WRITE(7,1007) (POS(I),BAK(I),I=1,NB)
      CALL READER(3,TEXT,0,TOUT,0,IHIGH,2,.TRUE.)
      MREFL=IHIGH(1)
      IHIGH(1)=IHIGH(2)
*
*     When MREFL is negative, the lower and upper limits of those parts
*     of the diagram, which have to be excluded from the calculations,
*     have to be read in.
*
      NCU=0
      IF(MREFL .GT. 0) GO TO 30
      I=1
   20 IF(I.EQ.1) THEN
         LOW(I)=-MREFL
         IHIGH(I)=-IHIGH(I)
      ELSE
         CALL READER(3,TEXT,0,TOUT,0,NH,2,.TRUE.)
         LOW(I)=-NH(1)
         IHIGH(I)=-NH(2)
      END IF
      IF(LOW(I).NE.100) THEN
         I=I+1
         GO TO 20
      END IF
      NCU=I-1
      WRITE(7,1008) (LOW(I),IHIGH(I),I=1,NCU)
      CALL READER(3,TEXT,0,TOUT,0,NH,1,.TRUE.)
      MREFL=NH(1)
   30 IF(NCU.EQ.0) WRITE(7,1009)
*
*     Read in denominators of Miller indices.
*
      CALL READER(3,TEXT,0,TOUT,0,NH,3,.TRUE.)
      WRITE(7,1010)
      WRITE(7,1011) (NH,I=1,3)
*
*     Read reflections and calculate for each the Lorentz factor,
*     the position and the halfwidth.
*
      DO 50 I=1,MREFL
      CALL READER(3,TEXT,0,TOUT,0,JCODE(I),1,.TRUE.)
      CALL READER(3,TEXT,0,TOUT,0,IH(1,I),3,.FALSE.)
      CALL READER(3,TEXT,0,TOUT,0,M(I),1,.FALSE.)
      D=PCRYST(1)*IH(1,I)*IH(1,I)/(NH(1)*NH(1))+
     *  PCRYST(2)*IH(2,I)*IH(2,I)/(NH(2)*NH(2))+
     *  PCRYST(3)*IH(3,I)*IH(3,I)/(NH(3)*NH(3))+
     *  PCRYST(4)*IH(2,I)*IH(3,I)/(NH(2)*NH(3))+
     *  PCRYST(5)*IH(1,I)*IH(3,I)/(NH(1)*NH(3))+
     *  PCRYST(6)*IH(1,I)*IH(2,I)/(NH(1)*NH(2))
      D=SLABDA*D
      PLOR(I)=(1-POLAR+POLAR*CTHM*(1-2*D)**2)/(2*D*SQRT(1-D))
      TG=SQRT(D/(1-D))
      TL(I)=ATAN(TG)*CONST+PINSTR(9)+PINSTR(10)/TG
*
*     Complex part of Voigtian argument (=y) is a function of five
*     halfwidth parameters and Bragg angle:
*
      W2G=SQRT(PINSTR(3)/TG**2+TG*(PINSTR(4)*TG+PINSTR(5))+PINSTR(6))
      Y=SQRLN2*(PINSTR(7)*TG+PINSTR(8)/SQRT(1-D))/W2G
      SJJ(I)=W2G*APPROX(Y)/EXPERF(Y)
   50 INDEX(I)=0
*
*     Sort angles in ascending order.
*
      CALL SORT(TL,LL,MREFL)
      DO 60 I=1,MREFL
      J=LL(I)
      T(I)=TL(J)
   60 HW(I)=SJJ(J)
*
*     Read in profile intensities.
*
      CALL READER(3,TEXT,0,TOUT,0,IOUT,3,.TRUE.)
      IALFA=IOUT(1)
      ISTAP=IOUT(2)
      IOMEG=IOUT(3)
      POS(NB+1)=IOMEG+ISTAP
      BAK(NB+1)=BAK(NB)
      MAXR=MREFL
      PI=0.01*ISTAP*SQRT(CONST)
      JJ=1
      I=1
      MINR=1
      IS=IALFA
*
*     Read in one record of 10 intensities.
*
   70 J=JJ-(JJ-1)/10*10
      JJ9=JJ+9
      IF(J.EQ.1) CALL READER(3,TEXT,0,YOBS(JJ),10,IOUT,0,.TRUE.)
      Y=YOBS(JJ)
*
*     Determine whether intensity is in excluded range.
*
      IORD(JJ)=0
      DO 80 J=1,NCU
      IF(IS.GE.LOW(J).AND.IS.LE.IHIGH(J)) Y=0
   80 YOBS(JJ)=Y
      IF(Y.EQ.0) GO TO 110
      MARK=.FALSE.
*
*     Determine what reflections can contribute to intensity i.e. are
*     within CUT*HALFWIDTH from intensity position.
*
      DO 90 J=MINR,MAXR
      WIDTH=CUT*HW(J)
      ST=T(J)
      MIN=ST-WIDTH+0.5
      MAX=ST+WIDTH+0.5
      IF(IS.GE.MIN.AND.IS.LE.MAX) THEN
         IF(.NOT.MARK) THEN
            I=J
            IORD(JJ)=J
            MARK=.TRUE.
         END IF
         INDEX(J)=-1
      ELSE
         IF(MARK) GO TO 100
      END IF
   90 CONTINUE
      J=MAXR+1
  100 IF(MARK) IORD(JJ)=IORD(JJ) + OFFSET*(J-1)
      MINR=I
  110 IS=IS+ISTAP
      JJ=JJ+1
      IF(IS.LE.IOMEG) GO TO 70
*
*     Determination of total number of reflections within range
*     concerned.
*
      CLOSE(UNIT=3,STATUS='KEEP')
      DO 120 I=1,JJ-1
  120 IF(MOD(IORD(I),OFFSET) .EQ. 0) YOBS(I)=0
      NREFL=0
      DO 130 I=1,MREFL
      IF(INDEX(I).EQ.-1) NREFL=NREFL+1
  130 CONTINUE
*
*     Write data on disk and print reflections.
*
      JJ=1
      I=0
      NC=1
      DO 160 IS=1,MREFL
      LLS=LL(IS)
      IF(INDEX(IS).EQ.-1) THEN
         I=I+1
         TL(IS)=I
         ICODE(JJ)=JCODE(LLS)
         DO 140 J=1,3
  140    HKL(J,JJ)=IH(J,LLS)
         SJJ(JJ)=M(LLS)*PI*PLOR(LLS)
         JJ=JJ+1
         IOUT(NC)=I
      ELSE
         TL(IS)=0
         IOUT(NC)=8888
      END IF
      ICOUT(NC)=JCODE(LLS)
      DO 150 J=1,3
  150 IHOUT(J,NC)=IH(J,LLS)
      MOUT(NC)=M(LLS)
      HWOUT(NC)=HW(IS)
      TOUT(NC)=T(IS)
      IF(NC.NE.3.AND.IS.NE.MREFL) GO TO 160
      WRITE(7,1012) (IOUT(J),ICOUT(J),(IHOUT(IZ,J),IZ=1,3),MOUT(J),
     *               HWOUT(J),TOUT(J),J=1,NC)
      NC=0
  160 NC=NC+1
*
*     Correct for background and print profile intensities.
*
      CLOSE(UNIT=7,STATUS='KEEP')
      OPEN(UNIT=8,STATUS='NEW',FORM='FORMATTED')
      WRITE(8,1013) IALFA,IOMEG,ISTAP
      WRITE(8,1014)
      I=IALFA
      JJ=1
      IZ=0
      NZ=0
  170 Y=YOBS(JJ)
      IF(Y.EQ.0) THEN
         NZ=NZ+1
         IZ=1
         YOBS(JJ)=0
         WEIGHT(JJ)=0
         GO TO 220
      ELSE
         DO 180 J=1,NB+1
         J1=J-1
         IF(J1.EQ.0) J1=1
         IF(IFIX(POS(J)).LE.I) GO TO 180
         BACK=BAK(J1)
         IF(J.NE.J1)
     *   BACK=BACK+(I-POS(J1))/(POS(J)-POS(J1))*(BAK(J)-BAK(J1))
         GO TO 190
  180    CONTINUE
      END IF
  190 W=250/Y
      YL=Y-BACK
      IF(YL.EQ.0) YL=1
  200 IF(IZ.NE.1) GO TO 210
      IF(NZ.LE.4) THEN
         WRITE(8,1015) (0,K=1,NZ)
      ELSE
         WRITE(8,1015) 0,0
         WRITE(8,1016) NZ-4
         WRITE(8,1015) 0,0
      END IF
      IF(I.GT.IOMEG) GO TO 230
      IZ=0
      NZ=0
  210 YOBS(JJ)=YL
      WEIGHT(JJ)=W
*
*     Write profile on disk file.
*
      K1=MOD(IORD(JJ),OFFSET)
      K2=IORD(JJ)/OFFSET
      K1=TL(K1)+0.5
      K2=TL(K2)+0.5
      IORD(JJ) = K1 + OFFSET * K2
      WRITE(8,1017) I,Y,BACK,YL,W,K1,K2,(STAR,K=K1,K2)
  220 I=I+ISTAP
      JJ=JJ+1
      IF(I.LE.IOMEG) GO TO 170
      IF(IZ.EQ.1) GO TO 200
  230 CLOSE(UNIT=8,STATUS='KEEP')
      NCHAN=(IOMEG-IALFA+ISTAP)/ISTAP
      RETURN

 1000 FORMAT('1PREPARATION OF NEUTRON AND X-RAY POWDER PROFILE INTEN',
     *       'SITIES FOR MAGNETIC AND NUCLEAR STRUCTURE REFINEMENT ',
     *       'PROGRAM.',/,'0FORTRAN 77 VERSION  8-OCT-1987',/)
 1001 FORMAT('0WAVELENGTH =',F7.4)
 1002 FORMAT('0HALFWIDTH PARAMETERS')
 1003 FORMAT('   T =',F10.3,'   U =',F10.3,'   V =',F10.3,'   W =',F10.3,
     *       '   X =',F10.3,'   Y =',F10.3)
 1004 FORMAT('0ZEROPOINT  =',2F6.2)
 1005 FORMAT('   CTHM   Polarization   CUT-value',/,F8.5,F12.5,F12.2)
 1006 FORMAT('0BACKGROUND',/,' POSITION',4X,'INTENSITY')
 1007 FORMAT(1X,F7.0,6X,F6.0)
 1008 FORMAT('0EXCLUDED REGIONS = FROM     TO',/,(20X,I6,I7))
 1009 FORMAT('0NO EXCLUDED REGIONS.')
 1010 FORMAT(/,3('    NO. CODE  H  K  L  MULT   HW     POSN',2X))
 1011 FORMAT(3(12X,3I3,22X))
 1012 FORMAT(3(1X,2I5,I4,2I3,I5,F7.1,F9.1,1X))
 1013 FORMAT('0DIAGRAM FROM',I6,' TO',I6,' IN STEPS OF',I3,
     *       ' 1/100ths DEGREE')
 1014 FORMAT('0  POSN   I+B',6X,'B     I',7X,'W',8X,'PEAKS',7X,'SHAPE')
 1015 FORMAT(1X,I12)
 1016 FORMAT(6X,'(',I4,' ZEROS)')
 1017 FORMAT(1X,I6,3F7.0,F9.4,I5,' -',I4,5X,(79A1))
      END

*     ****************
      SUBROUTINE INPUT
*     ****************
*
*     This subroutine reads and prints the input data and initializes
*     other data.
*
      CHARACTER ATEXT*4,NAME(10)*2,TEXT*80
      REAL F(21,10),FLAG(6),S(21,10)
      INTEGER IFLAG(6)
      INCLUDE 'COMMONS.FOR'
      COMMON/CHARS/ATEXT(30),TEXT
      COMMON/SPACE/JUMP,A,B,C,COSALF,COSBET,COSGAM,SINALF,SINBET,SINGAM
      COMMON/IO/EPS,RELAX,RELAXB,RELAXC,SUMOBS,SUMW,SUMWBS,SW,IPONS,
     *          LMAT,LOUT,NUM
      COMMON/DATA/CUT,NREFL,NH(3),IALFA,ISTAP,NCHAN,ICODE(999),
     *       HKL(3,999),SJJ(999),YOBS(15000),WEIGHT(15000),IORD(15000)
      COMMON/PARAMS/AINSTR(10),ACRYST(22), ATOM(14,30),
     *              LINSTR(10),LCRYST(22),LATOM(14,30),
     *              PINSTR(10),PCRYST(22),PATOM(14,30)
      COMMON/CONSTR/ML,LN(4),COEF(4,10),IL(4,9),JL(4,9),IQ(4,9),JQ(4,9)
      SAVE
      DATA RAD/1.7453292520E-2/

      CALL TIMES(1)
*
*     Read and print problem title. Subroutine TIMES gives the
*     elapsed CPU-time.
*
      WRITE(6,1001)
      READ(5,'(A)') TEXT
      CALL TIMES(2)
      WRITE(6,1002) TEXT
*
*     Find out the space group of crystal structure.
*     Read incident angle to specify measurement geometry
*     and define which radiation was used, neutrons or X-rays.
*
      CALL GROUP(ANGLE,XRAYS)
*
*     Read and print problem parameters.
*
      CALL READER(5,TEXT,0,FLAG,1,IFLAG,2,.TRUE.)
      EPS=FLAG(1)
      K=IFLAG(1)
      LIM=IFLAG(2)
      CALL READER(5,TEXT,0,FLAG,0,IFLAG,6,.TRUE.)
      ICENT=IFLAG(1)
      IRL=IFLAG(2)
      KL=IFLAG(3)
      KM=IFLAG(4)
      N=IFLAG(5)
      MAGROT=IFLAG(6)
      CALL READER(5,TEXT,0,FLAG,1,IFLAG,0,.FALSE.)
      SLABDA=FLAG(1)
      IRL=IRL+1
      WRITE(6,1003) EPS
      HALPER=.FALSE.
      UNIAX=.FALSE.
      CUBIC=.FALSE.
      IF(K.EQ.1) THEN
         WRITE(6,1004)
         HALPER=.TRUE.
      ELSE IF(K.EQ.2) THEN
         WRITE(6,1005)
         UNIAX=.TRUE.
      ELSE IF(K.EQ.3) THEN
         WRITE(6,1006)
         CUBIC=.TRUE.
      END IF
*
*     At this point SLABDA equals to wavelength in Angstroms.
*
      WRITE(6,1007) SLABDA
*
*     Read equivalent position vector and matrices.
*
      DO 30 I=1,3
      EQUIV(4,I,1)=0
      DO 30 J=1,3
      IJ=(I-1)*3+J
      IF(I.EQ.J) THEN
         EQUIV(J,I,1)=1
      ELSE
         EQUIV(J,I,1)=0
      END IF
      IF(I.EQ.J.OR.MAGROT.GT.0) THEN
         DO 20 K=1,MAGROT
         IF(I.EQ.J) RM(IJ,K,1)=1
         IF(I.NE.J) RM(IJ,K,1)=0
   20    CONTINUE
      END IF
   30 CONTINUE
*                                   Line 5 and 6.
      DO 50 IR=2,IRL
      CALL READER(5,TEXT,0,EQUIV(1,1,IR),12,IFLAG,0,.TRUE.)
      DO 40 K=1,MAGROT
   40 CALL READER(5,TEXT,0,RM(1,K,IR),9,IFLAG,0,.TRUE.)
   50 CONTINUE
*
*     Read scattering lengths and dispersion corrections, if any.
*     Lines 7-9.
*
      IF(KL.GT.0) CALL READER(5,TEXT,0,SCAT,KL,IFLAG,0,.TRUE.)
      IF(KM.GT.0 .AND. XRAYS) THEN
         CALL READER(5,TEXT,0,DISPRE,KM,IFLAG,0,.TRUE.)
         CALL READER(5,TEXT,0,DISPIM,KM,IFLAG,0,.TRUE.)
      END IF
*
*     Read atom names and scattering curves.
*
      DO 60 I=1,KM
      CALL READER(5,NAME(I),2,FLAG,0,IFLAG,0,.TRUE.)
      TYPE=.TRUE.
      DO 60 J=1,21
      IF(TYPE) THEN
         CALL READER(5,TEXT,0,S(J,I),1,IFLAG,0,.TRUE.)
         CALL READER(5,TEXT,0,F(J,I),1,IFLAG,0,.FALSE.)
         IF(S(J,I).EQ.-100) THEN
            TYPE=.FALSE.
            S(J,I)=S(J-1,I)
            X=S(J,I)
            F(J,I)=F(J-1,I)
            Y=F(J,I)
         END IF
      ELSE
         S(J,I)=X
         F(J,I)=Y
      END IF
   60 CONTINUE
*
*     Read number of cycles, relaxation factors and output parameters.
*     Line 12.
*
      CALL READER(5,TEXT,0,FLAG,0,IFLAG,1,.TRUE.)
      NCYCLE=IFLAG(1)
      CALL READER(5,TEXT,0,FLAG,3,IFLAG,3,.FALSE.)
      RELAXC=FLAG(1)
      RELAXB=FLAG(2)
      RELAX=FLAG(3)
      LOUT=IFLAG(1)
      IPONS=IFLAG(2)
      LMAT=IFLAG(3)
*
*     From this on SLABDA equals to wavelength**2/4.
*
      SLABDA=SLABDA*SLABDA/4
*
*     Print all input data.
*
      WRITE(6,1008) NCYCLE
      IF(LOUT.EQ.1) WRITE(6,1009)
      IF(LMAT.EQ.1) WRITE(6,1010)
      IF((IPONS.EQ.1).OR.(IPONS.EQ.3)) WRITE(6,1011)
      IF((IPONS.EQ.2).OR.(IPONS.EQ.3)) WRITE(6,1012)
      WRITE(6,1013) RELAXC,RELAXB,RELAX
      IF(ICENT.EQ.2) THEN
         WRITE(6,1014)
      ELSE
         WRITE(6,1015)
      END IF
      WRITE(6,1016)
      DO 80 IR=2,IRL
      WRITE(6,1017) ((EQUIV(J,I,IR),J=1,4),I=1,3)
      DO 70 K=1,MAGROT
   70 WRITE(6,1018) (RM(IJ,K,IR),IJ=1,9)
   80 CONTINUE
      IF(KL.GT.0) WRITE(6,1020) (I,SCAT(I),I=1,KL)
      IF(KM.GT.0) WRITE(6,1021)
      DO 100 I=1,KM
      WRITE(6,1022) NAME(I)
      DO 90 J=1,20
      WRITE(6,1023) S(J,I),F(J,I)
      IF((S(J,I).EQ.S(J+1,I)).AND.(F(J,I).EQ.F(J+1,I))) GO TO 100
   90 CONTINUE
  100 CONTINUE
      WRITE(6,1024)
*
*     Read scale and temp factors.
*
      CALL READER(5,TEXT,0,FLAG,2,IFLAG,0,.TRUE.)
      SCALE=FLAG(1)
      PCRYST(7)=FLAG(2)
      PINSTR(2)=1/SCALE
*
*     Read and print data for each atom.
*
      DO 120 I=1,N
      CALL READER(5,ATEXT(I),4,FLAG,0,IFLAG,3,.TRUE.)
      NTYP(I)=IFLAG(1)
      MTYP(I)=IFLAG(2)
      MEQ(I)=IFLAG(3)
      CALL READER(5,TEXT,0,PATOM(1,I),8,IFLAG,0,.FALSE.)
      CALL READER(5,TEXT,0,PATOM(9,I),6,IFLAG,0,.TRUE.)
      WRITE(6,1025) ATEXT(I),NTYP(I),MTYP(I),MEQ(I),(PATOM(J,I),J=1,14)
  120 CONTINUE
      WRITE(6,1026) SCALE,PCRYST(7)
*
*     Read and print halfwidth and zeropoint parameters.
*
      CALL READER(5,TEXT,0,PINSTR(3),8,IFLAG,0,.TRUE.)
      WRITE(6,1027) PINSTR(9),PINSTR(10)
      WRITE(6,1028) (PINSTR(I),I=3,8)
*
*     IFLAG(1) .GE. 0  <===>  a, b, c, alpha, beta, gamma are given.
*     IFLAG(1) .LT. 0  <===>  The coefficients of products of Miller
*                             indices are given.
*     In former case the conversion to latter case is performed.
*
      CALL READER(5,TEXT,0,FLAG,0,IFLAG,1,.TRUE.)
      CALL READER(5,TEXT,0,PCRYST,6,IFLAG,0,.TRUE.)
      IF(IFLAG(1) .LT. 0) THEN
         CALL PROFIL
      ELSE
         A=PCRYST(1)
         B=PCRYST(2)
         C=PCRYST(3)
         COSALF=COS(RAD*PCRYST(4))
         COSBET=COS(RAD*PCRYST(5))
         COSGAM=COS(RAD*PCRYST(6))
         SINALF=SQRT(1-COSALF**2)
         SINBET=SQRT(1-COSBET**2)
         SINGAM=SQRT(1-COSGAM**2)
         VOL=A*B*C*SQRT(1-COSALF*COSALF-COSBET*COSBET-COSGAM*COSGAM+
     *       2*COSALF*COSBET*COSGAM)
         AS=B*C*SINALF/VOL
         BS=C*A*SINBET/VOL
         CS=A*B*SINGAM/VOL
         COSAS=(COSBET*COSGAM-COSALF)/(SINBET*SINGAM)
         COSBS=(COSGAM*COSALF-COSBET)/(SINGAM*SINALF)
         COSCS=(COSALF*COSBET-COSGAM)/(SINALF*SINBET)
         PCRYST(1)=AS*AS
         PCRYST(2)=BS*BS
         PCRYST(3)=CS*CS
         PCRYST(4)=2*BS*CS*COSAS
         PCRYST(5)=2*AS*CS*COSBS
         PCRYST(6)=2*AS*BS*COSCS
*
*     CONVERT B(I,J) TO BETA(I,J)
*
         DO 130 I=1,N
         PATOM( 9,I)=PATOM( 9,I)*AS*AS/4
         PATOM(10,I)=PATOM(10,I)*BS*BS/4
         PATOM(11,I)=PATOM(11,I)*CS*CS/4
         PATOM(12,I)=PATOM(12,I)*AS*BS/4
         PATOM(13,I)=PATOM(13,I)*AS*CS/4
  130    PATOM(14,I)=PATOM(14,I)*BS*CS/4
      END IF
      WRITE(6,1029) (PCRYST(I),I=1,6)
*
*     Get preparation data.
*
      CALL PREPAR
      CALL GEOMET(ANGLE)
      J=0
      SW=0
      SUMOBS=0
      SUMWBS=0
      DO 10 I=1,NCHAN
      IF(ABS(YOBS(I)).LT.0.001) THEN
         J=J+1
         YOBS(I)=0
      ELSE
         SW=SW+WEIGHT(I)
         SUMOBS=SUMOBS+ABS(YOBS(I))
         SUMWBS=SUMWBS+WEIGHT(I)*YOBS(I)*YOBS(I)
      END IF
   10 CONTINUE
      NUM=NCHAN-J
*
*     Read and write asymmetry parameter and texture parameters.
*
      CALL READER(5,TEXT,0,PINSTR,1,IFLAG,0,.TRUE.)
      CALL READER(5,TEXT,0,PCRYST(8),15,IFLAG,0,.TRUE.)
      WRITE(6,1030) PINSTR(1),(PCRYST(J),J=8,22)
      DO 160 I=1,N
      DO 160 J=1,14
      ATOM(J,I)=0
  160 LATOM(J,I)=0
      WRITE(6,1031) NREFL,CUT
      MAXCON=0
*
*     Read the number of refinement parameters.
*
      CALL READER(5,TEXT,0,FLAG,0,IFLAG,1,.TRUE.)
      MAXS=IFLAG(1)
      IF(MAXS.EQ.0) GO TO 230
      WRITE(6,1032)
*
*     Read and print codewords for atomic parameters.
*
      DO 180 I=1,N
      CALL READER(5,TEXT,0,ATOM(1,I),8,IFLAG,0,.TRUE.)
      CALL READER(5,TEXT,0,ATOM(9,I),6,IFLAG,0,.TRUE.)
      WRITE(6,1033) ATEXT(I),(ATOM(J,I),J=1,14)
      DO 170 J=1,14
  170 ATOM(J,I)=CODING(ATOM(J,I),LATOM(J,I))
  180 CONTINUE
*
*     Read and print codewords
*        - for scale, temperature factor
*        - zero point and halfwidth parameters
*        - for cell constants
*        - for asymmetry parameter and texture parameters.
*
      CALL READER(5,TEXT,0,AINSTR(2),1,IFLAG,0,.TRUE.)
      CALL READER(5,TEXT,0,ACRYST(7),1,IFLAG,0,.FALSE.)
      WRITE(6,1034) AINSTR(2)
      WRITE(6,1035) ACRYST(7)
      CALL READER(5,TEXT,0,AINSTR(3),8,IFLAG,0,.TRUE.)
      WRITE(6,1036) AINSTR(9),AINSTR(10)
      WRITE(6,1037) (AINSTR(J),J=3,8)
      CALL READER(5,TEXT,0,ACRYST,6,IFLAG,0,.TRUE.)
      WRITE(6,1038) (ACRYST(J),J=1,6)
      CALL READER(5,TEXT,0,AINSTR,1,IFLAG,0,.TRUE.)
      CALL READER(5,TEXT,0,ACRYST(8),15,IFLAG,0,.TRUE.)
      WRITE(6,1039) AINSTR(1)
      WRITE(6,1040) (ACRYST(J),J=8,22)
      DO 190 I=1,10
  190 AINSTR(I)=CODING(AINSTR(I),LINSTR(I))
      DO 200 I=1,22
  200 ACRYST(I)=CODING(ACRYST(I),LCRYST(I))
*
*     STEADY = TRUE means cell constants to be varied. So COORD and
*     PROFIL must be called at the beginning of each cycle (see ITER).
*
      STEADY = LCRYST(1) + LCRYST(2) + LCRYST(3) +
     *         LCRYST(4) + LCRYST(5) + LCRYST(6) .EQ. 0
*
*     Read constraints if any.
*
      CALL READER(5,TEXT,0,FLAG,0,IFLAG,2,.TRUE.)
      ML=IFLAG(1)
      MQ=IFLAG(2)
      MAXCON=ML+MQ
      K=0
      DO 220 I=1,MAXCON
  210 K=K+1
*
*     Read coefficient and indices for constraint functions.
*
      CALL READER(5,TEXT,0,COEF(I,K),1,IFLAG,4,.TRUE.)
*
*                             Linear or quadratic indices.
      IF(IFLAG(1).GT.0) THEN
         IL(I,K)=IFLAG(1)
         JL(I,K)=IFLAG(2)
*                             Quadratic indices.
         IQ(I,K)=IFLAG(3)
         JQ(I,K)=IFLAG(4)
         IF(K.LT.10) GO TO 210
      END IF
*                             Last term.
      COEF(I,10)=COEF(I,K)
      LN(I)=K-1
      K=0
  220 CONTINUE
  230 WRITE(6,1041) MAXS
      IF(MAXCON.EQ.0) THEN
         WRITE(6,1042)
         GO TO 260
      END IF
      WRITE(6,1043) MAXCON
      DO 240 I=1,ML
      LNI=LN(I)
      WRITE(6,1044) (COEF(I,J),IL(I,J),JL(I,J),J=1,LNI)
  240 WRITE(6,1045) COEF(I,10)
      DO 250 K=1,MQ
      I=K+ML
      LNI=LN(I)
      WRITE(6,1046) (COEF(I,J),IL(I,J),JL(I,J),IQ(I,J),JQ(I,J),J=1,LNI)
  250 WRITE(6,1045) COEF(I,10)
*
*     Calculate for each reflection alpha**2.
*
  260 DO 310 I=1,NREFL
      DO 280 J=1,3
  280 HKL(J,I)=HKL(J,I)/NH(J)
      X=PCRYST(1)*HKL(1,I)*HKL(1,I)+PCRYST(2)*HKL(2,I)*HKL(2,I)+
     *  PCRYST(3)*HKL(3,I)*HKL(3,I)+PCRYST(4)*HKL(2,I)*HKL(3,I)+
     *  PCRYST(5)*HKL(1,I)*HKL(3,I)+PCRYST(6)*HKL(1,I)*HKL(2,I)
      IF(UNIAX.AND.(ICODE(I).NE.1)) THEN
         Y=(PCRYST(3)*HKL(3,I)+PCRYST(4)*HKL(2,I)/2+
     *                         PCRYST(5)*HKL(1,I)/2)/NH(3)**2
         FAC(I)=(Y*NH(3))**2/(X*PCRYST(3))
      END IF
*
*     COORD is called define cartesian coordinate orientation.
*
      CALL COORD(HKL(1,I),I)
*
      X=SQRT(X)/2
      DO 300 J=1,KM
      DO 290 K=1,20
      K1=MAX(K-1,1)
      IF(X.GT.S(K,J)) GO TO 290
      FF(I,J)=(S(K1,J)-X)/(S(K1,J)-S(K,J))*(F(K,J)-F(K1,J))+F(K1,J)
      GO TO 300
  290 CONTINUE
      FF(I,J)=F(20,J)
  300 CONTINUE
  310 CONTINUE
      CALL TIMES(1)
      RETURN
 1001 FORMAT('1NUCLEAR AND MAGNETIC STRUCTURE REFINEMENT PROGRAM FOR ',
     1       'NEUTRON AND X-RAY POWDER PROFILES - FORTRAN 77 VERSION ',
     2       '- OCTOBER 1987')
 1002 FORMAT('0******    ',A80,' ******',/)
 1003 FORMAT(' Convergence criteria: EPS =',F6.1)
 1004 FORMAT(' MAGNETIC INTENSITIES CALCULATION ACCORDING TO HALPERN',
     1       ' AND JOHNSON.')
 1005 FORMAT(' UNIAXIAL CONFIGURATIONAL SPIN SYMMETRY.')
 1006 FORMAT(' CUBIC CONFIGURATIONAL SPIN SYMMETRY.')
 1007 FORMAT('0WAVELENGTH =',F11.7)
 1008 FORMAT(' NUMBER OF CYCLES=',I6)
 1009 FORMAT(' PRINTED OUTPUT OF OBS + CALC INTENSITIES ON LAST CYCLE')
 1010 FORMAT(' PRINTED OUTPUT OF CORRELATION  -  MATRIX ON LAST CYCLE')
 1011 FORMAT(' PUNCHED OUTPUT OF STRUCTURE FACTOR TAPE  ON LAST CYCLE')
 1012 FORMAT(' PUNCHED OUTPUT OF OBS + CALC INTENSITIES ON LAST CYCLE')
 1013 FORMAT('0RELAXATION FACTORS',/,' FOR COORDINATES    =',F5.2,/,
     1      ' FOR TEMP FACTORS   =',F5.2,/,' FOR SCALING FACTORS=',F5.2)
 1014 FORMAT('0THE STRUCTURE IS CENTROSYMMETRIC.')
 1015 FORMAT('0THE STRUCTURE IS NON CENTROSYMMETRIC.')
 1016 FORMAT('0EQUIVALENT POSITIONS=')
 1017 FORMAT(5X,3F5.1,F13.2,/,:,' R=  ',3F5.1,4X,'T=',F7.2)
 1018 FORMAT(5X,3F5.1,/,' M=  ',3F5.1,/,5X,3F5.1,/)
 1020 FORMAT('0SCATTERING LENGTHS:',(T22,'B(',I1,') =',F7.3))
 1021 FORMAT('0FORMFACTORS')
 1022 FORMAT(/,10X,A2,/,' SINTH/LAMBDA      F')
 1023 FORMAT(1X,F8.4,F13.4)
 1024 FORMAT('0***INITIAL PARAMETERS***',/,' ATOM NTP MTP MRT',3X,'X',
     1        7X,'Y',7X,'Z',7X,'B',7X,'N',7X,'KX',6X,'KY',6X,'KZ',6X,
     2        'B11',5X,'B22',5X,'B33',5X,'B12',5X,'B13',5X,'B23')
 1025 FORMAT(1X,A4,I3,2I4,14F8.5)
 1026 FORMAT('0OVERALL SCALE FACTOR=',F12.6,/,' OVERALL TEMP. FACTOR=',
     *       F12.6)
 1027 FORMAT('0ZEROPOINT=',F23.6,F12.6)
 1028 FORMAT('0HALFWIDTH PARAMETERS:',/,' GAUSSIAN  =',10X,4F12.4,/,
     *       ' LORENTZIAN=',10X,2F12.4)
 1029 FORMAT('0CELL CONSTANTS=',6X,6F12.7)
 1030 FORMAT('0ASYMMETRY PARAMETER= ',F12.6,/,
     *       ' TEXTURE PARAMETERS = ',8F12.6,/,22X,8F12.6)
 1031 FORMAT('0For this analysis ',I4,' reflections',
     *       ' are used with CUT =',F5.1,'.') 
 1032 FORMAT('0***CODING OF VARIABLES***',/,' ATOM',16X,'X',7X,'Y',7X,
     1       'Z',7X,'B',7X,'N',6X,'KX',6X,'KY',6X,'KZ',6X,'B11',5X,
     2       'B22',5X,'B33',5X,'B12',5X,'B13',5X,'B23')
 1033 FORMAT(1X,A4,10X,14F8.3)
 1034 FORMAT('0OVERALL SCALE FACTOR=',F8.2)
 1035 FORMAT(' OVERALL TEMP. FACTOR=',F8.2)
 1036 FORMAT('0ZEROPOINT=',F19.2,F8.2)
 1037 FORMAT('0HALFWIDTH PARAMETERS:',/,' GAUSSIAN  =',10X,4F8.2,/,
     *       ' LORENTZIAN=',10X,2F8.2)
 1038 FORMAT('0CELL CONSTANTS=',6X,6F8.2)
 1039 FORMAT('0ASYMMETRY PARAMETER=',F9.2)
 1040 FORMAT(' TEXTURE PARAMETERS = ',8F8.2,/,22X,8F8.2,/)
 1041 FORMAT(/,'0TOTAL NUMBER OF VARIABLES =',I3)
 1042 FORMAT(' NO CONSTRAINT FUNCTIONS.')
 1043 FORMAT(1X,I2,' CONSTRAINT FUNCTIONS =',/)
 1044 FORMAT(8(F6.2,' * X(',I1,',',I2,')'))
 1045 FORMAT(10X,'=',E12.5,/)
 1046 FORMAT(5(F6.2,' * X(',I1,',',I2,') * X(',I1,',',I2,')'))
      END

*     ****************
      SUBROUTINE EXPUT
*     ****************
*
*     This subroutine outputs the data on disk files.
*
      INTEGER IN(3)
      INCLUDE 'COMMONS.FOR'
      COMMON/DATA/CUT,NREFL,NH(3),IALFA,ISTAP,NCHAN,ICODE(999),
     *       HKL(3,999),SJJ(999),YOBS(15000),WEIGHT(15000),IORD(15000)
      SAVE
      DATA SQRPI/1.7724538509/
*
      IF(YES) THEN
         WRITE(13,1000) NREFL
         DO 20 I=1,NREFL
         DO 10 J=1,3
   10    IN(J)=HKL(J,I)*NH(J)
         MLT=SJJ(I)
         X=BRAGG(I)/100
   20    WRITE(13,1000) ICODE(I),IN,MLT,X,FNUC(I),FMAG(I)
         WRITE(13,1001)
         CLOSE(UNIT=13,STATUS='KEEP')
      END IF
      IF(PUNCH) THEN
         OPEN(UNIT=18,STATUS='NEW',FORM='FORMATTED'
     *        ,CARRIAGECONTROL='LIST'                         ! VAX/VMS
     *        )
         WRITE(18,1000) NREFL
         WRITE(18,1000) NH
         ARG=SQRPI/(ISTAP*SCALE)
         DO 40 I=1,NREFL
         BB=SJJ(I)*ARG
         DO 30 J=1,3
   30    IN(J)=HKL(J,I)*NH(J)
         X=0
         IF(FNUC(I)+FMAG(I).GT.0) X=FOBS(I)/(FNUC(I)+FMAG(I))
         X1=FNUC(I)/BB
         X2=X1*X
         X3=FMAG(I)/BB
         X4=X3*X
         X5=0
         IF(FOBS(I).NE.0) X5=FESD(I)/FOBS(I)
   40    WRITE(18,1002) IN,X1,X2,X3,X4,X5
         CLOSE(UNIT=18,STATUS='KEEP')
      END IF
      WRITE(6,1003)
      RETURN
 1000 FORMAT(5I8,F8.3,2F8.0)
 1001 FORMAT(/)
 1002 FORMAT(3I8,4F8.2,F8.4)
 1003 FORMAT(//,1X,129('+'))
      END

*     *******************
      SUBROUTINE TIMES(N)
*     *******************
*
*     This routine prints the cumulating processing time of current job
*     if N = 1. Otherwise the date and time are printed.
*
*     Operating system dependence:  VAX/VMS          !  VAX/VMS
*                                                    !  VAX/VMS
      CHARACTER*23 A                                 !  VAX/VMS
      Logical Initialized/.False./                   !  VAX/VMS
      Integer*4 Handle,Status                        !  VAX/VMS
      IF(N.NE.1) GO TO 10                            !  VAX/VMS
      If(.Not.Initialized) then                      !  VAX/VMS
         Initialized=.True.                          !  VAX/VMS
         If(.Not.Lib$Init_Timer(Handle)) go to 20    !  VAX/VMS
         RETURN                                      !  VAX/VMS
      End If                                         !  VAX/VMS
      If(.Not.Lib$Show_Timer(Handle,2)) go to 20     !  VAX/VMS
      RETURN                                         !  VAX/VMS
   10 Status=Lib$Date_Time(A)                        !  VAX/VMS
      If(.Not.Status) Go to 20                       !  VAX/VMS
      WRITE(6,300) A(1:11),A(12:23)                  !  VAX/VMS
      RETURN                                         !  VAX/VMS
   20 Stop 'VAX timing routine error -- terminated'  !  VAX/VMS
*
  300 FORMAT(//,20X,'**********  DATE:  ',A,'  TIME:  ',A,
     *       '  **********',//)
      END

*     ***********************
      SUBROUTINE UPDATE(SKEW)
*     ***********************
*
*     This subroutine prints all relevant data after each cycle.
*
      CHARACTER ATEXT*4,TEXT*80
      REAL SIGMA(8),SMOM(3),SY(14),SZ(6,30)
      INCLUDE 'COMMONS.FOR'
      COMMON/CHARS/ATEXT(30),TEXT
      COMMON/IO/EPS,RELAX,RELAXB,RELAXC,SUMOBS,SUMW,SUMWBS,SW,IPONS,
     *          LMAT,LOUT,NUM
      COMMON/PARAMS/AINSTR(10),ACRYST(22), ATOM(14,30),
     *              LINSTR(10),LCRYST(22),LATOM(14,30),
     *              PINSTR(10),PCRYST(22),PATOM(14,30)
      COMMON/SPACE/JUMP,A,B,C,COSALF,COSBET,COSGAM,SINALF,SINBET,SINGAM
      SAVE
      DATA OLD/0.0/
*
*     MATRIX solves the least squares equation, if it exists.
*
      IF(MAXS.NE.0) CALL MATRIX(SKEW)
      WRITE(6,1003)
*
*     Update atom coordinates and temperature factors.
*
      DO 20 I=1,N
      DO 10 J=1,4
      FACTOR=RELAXB
      IF(J.LT.4) FACTOR=RELAXC
      SY(J)=STEP(FACTOR,ATOM(J,I),LATOM(J,I),Z)
      PATOM(J,I)=PATOM(J,I)+SY(J)
   10 SIGMA(J)=Z
   20 WRITE(6,1004) ATEXT(I),(PATOM(J,I),SY(J),SIGMA(J),J=1,4)
      WRITE(6,1005)
*
*     Update rest of the atom parameters.
*
      DO 40 I=1,N
      DO 30 J=9,14
      SY(J)=STEP(RELAXB,ATOM(J,I),LATOM(J,I),Z)
      PATOM(J,I)=PATOM(J,I)+SY(J)
   30 SZ(J-8,I)=Z
   40 WRITE(6,1006) ATEXT(I),(PATOM(J,I),SY(J),SZ(J-8,I),J=9,14)
      WRITE(6,1007)
      DO 90 I=1,N
      DO 50 J=5,8
      IF((MTYP(I).NE.0).OR.(J.EQ.5)) THEN
         SY(J)=STEP(RELAX,ATOM(J,I),LATOM(J,I),Z)
         PATOM(J,I)=PATOM(J,I)+SY(J)
         SIGMA(J)=Z
      ELSE
         PATOM(J,I)=0
         SY(J)=0
         SIGMA(J)=0
      END IF
   50 CONTINUE
      IF(MTYP(I).EQ.0) GO TO 80
      Z=0
      SMOM(1)=PATOM(6,I)+PATOM(8,I)*COSBET+PATOM(7,I)*COSGAM
      SMOM(2)=PATOM(7,I)+PATOM(6,I)*COSGAM+PATOM(8,I)*COSALF
      SMOM(3)=PATOM(8,I)+PATOM(7,I)*COSALF+PATOM(6,I)*COSBET
      DO 70 J=1,3
      DO 70 K=1,3
      LJ=LATOM(J+5,I)
      LK=LATOM(K+5,I)
      X1=0
      IF(LJ*LK.NE.0) X1=SMM(LJ,LK)*ATOM(J+5,I)*ATOM(K+5,I)
   70 Z=Z+SMOM(J)*SMOM(K)*X1
      Y=PATOM(6,I)**2+PATOM(7,I)**2+PATOM(8,I)**2+
     *  2*(PATOM(7,I)*PATOM(8,I)*COSALF+PATOM(6,I)*PATOM(8,I)*COSBET+
     *     PATOM(6,I)*PATOM(7,I)*COSGAM)
      Z=SQRT(Z/Y)
      Y=SQRT(Y)
      YY=Y
      ZZ=Z
      GO TO 90
   80 YY=0
      ZZ=0
   90 WRITE(6,1008) ATEXT(I),(PATOM(J,I),SY(J),SIGMA(J),J=5,8),YY,
     *              YY-OLD,ZZ
      OLD=YY
*
*     Scale factor update.
*
      PINSTR(2)=PINSTR(2)+STEP(RELAX,AINSTR(2),LINSTR(2),Z)
      X=1/PINSTR(2)
      Y=X-SCALE
      Z=X*X*Z
      SCALE=X
      WRITE(6,1009) X,Y,Z
*
*     Overall temperature factor update.
*
      Y=STEP(RELAXB,ACRYST(7),LCRYST(7),Z)
      PCRYST(7)=PCRYST(7)+Y
      WRITE(6,1010) PCRYST(7),Y,Z
*
*     Zeropoint update.
*
      WRITE(6,1011)
      DO 100 J=9,10
      Y=STEP(0.8,AINSTR(J),LINSTR(J),Z)
      PINSTR(J)=PINSTR(J)+Y
      WRITE(6,1012) PINSTR(J),Y,Z
  100 CONTINUE
*
*     Halfwidth parameters update.
*
      WRITE(6,1013)
      DO 110 J=3,8
      Y=STEP(0.8,AINSTR(J),LINSTR(J),Z)
      PINSTR(J)=PINSTR(J)+Y
      WRITE(6,1014) PINSTR(J),Y,Z
  110 CONTINUE
*
*     Cell constants update.
*
      WRITE(6,1015)
      DO 120 J=1,6
      Y=STEP(0.8,ACRYST(J),LCRYST(J),Z)
      PCRYST(J)=PCRYST(J)+Y
  120 WRITE(6,1016) PCRYST(J),Y,Z
*
*     Asymmetry parameter update.
*
      Y=STEP(0.8,AINSTR(1),LINSTR(1),Z)
      PINSTR(1)=PINSTR(1)+Y
      WRITE(6,1017) PINSTR(1),Y,Z
*
*     Texture parameters update.
*
      DO 130 J=8,22
      Y=STEP(RELAXB,ACRYST(J),LCRYST(J),Z)
      PCRYST(J)=PCRYST(J)+Y
  130 WRITE(6,1016) PCRYST(J),Y,Z
      IF(TYPE) CALL DIRECT(SZ)
      RETURN
 1003 FORMAT('0NEW PARAMETERS, SHIFTS, AND STANDARD DEVIATIONS=',//,
     1       ' ATOM',7X,'X',7X,'DX',6X,'SX',9X,'Y',7X,'DY',6X,'SY',9X,
     2       'Z',7X,'DZ',6X,'SZ',9X,'B',7X,'DB',6X,'SB')
 1004 FORMAT(1X,A4,3X,4(3F8.5,3X))
 1005 FORMAT('0ATOM  B11   DB11   SB11    B22   DB22   SB22    B33   ',
     1       'DB33   SB33    B12   DB12   SB12    B13   DB13   SB13  ',
     2       '  B23   DB23   SB23')
 1006 FORMAT(1X,A3,18F7.4)
 1007 FORMAT('0ATOM    N',6X,'DN',6X,'SN',7X,'KX',5X,'DKX',5X,'SKX',7X,
     1'KY',5X,'DKY',5X,'SKY',7X,'KZ',5X,'DKZ',5X,'SKZ',8X,'M',6X,'DM',
     2 6X,'SM')
 1008 FORMAT(1X,A3,15(3F8.5,1X))
 1009 FORMAT('0OVERALL SCALE FACTOR=',3F8.4)
 1010 FORMAT(' OVERALL TEMP. FACTOR=',3F8.4)
 1011 FORMAT('0ZEROPOINT=')
 1012 FORMAT(1X,3F11.4)
 1013 FORMAT('0HALFWIDTH PARAMETERS=')
 1014 FORMAT(1X,3F11.2)
 1015 FORMAT('0CELL CONSTANTS=')
 1016 FORMAT(1X,3F11.7)
 1017 FORMAT('0ASYMMETRY PARAMETER=',/,1X,3F11.7,//,
     *       ' TEXTURE PARAMETERS=')
      END

*     ************************
      SUBROUTINE RADIAT(XRAYS)
*     ************************
*
*     This subroutine reads the incident angle and radiation type
*     and checks for their validity.
*
      LOGICAL XRAYS
*
      CHARACTER RAYS*1,SOURCE*7
      REAL FLAG(1)
      INTEGER IFLAG(1)
      INCLUDE 'BLANK.FOR'
      COMMON/DATA/CUT,NREFL,NH(3),IALFA,ISTAP,NCHAN,ICODE(999),
     *       HKL(999,3),SJJ(999),YOBS(15000),WEIGHT(15000),IORD(15000,2)
      DATA CONST/11459.155903/,RAD/1.7453292520E-2/
*
      CALL READER(RAYS,0,FLAG,1,IFLAG,0,.FALSE.)
      CALL READER(RAYS,1,FLAG,0,IFLAG,0,.FALSE.)
      IF(ABS(FLAG(1)).GT.90) THEN
         WRITE(6,1000) FLAG(1)
         FLAG(1)=0
      END IF
      IF(RAYS.EQ.'X'.OR.RAYS.EQ.'x') THEN
         XRAYS=.TRUE.
         SOURCE='X - ray'
      ELSE IF(RAYS.EQ.'N'.OR.RAYS.EQ.'n') THEN
         XRAYS=.FALSE.
         SOURCE='Neutron'
      ELSE
         WRITE(6,1001)
         STOP
      END IF
      WRITE(6,1002) SOURCE,FLAG(1)
      DO 10 I=1,NREFL
*                                  Reflection geometry     - alpha =  0
      IF(FLAG(1).EQ.0) THEN
         GEOM(I)=1
*                                  Transmission geometry and
*                                  Debye-Scherrer geometry - alpha = 90
      ELSE IF(FLAG(1).EQ.90) THEN
         GEOM(I)=0
*                                  Guinier geometries -
*                                  alpha = theta - incident angle
      ELSE
         GEOM(I)=COS(BRAGG(I)/CONST+RAD*FLAG(1))
      END IF
   10 CONTINUE
      RETURN
 1000 FORMAT(' Invalid incident angle =',F6.1,'. Zero assumed.')
 1001 FORMAT(' No radiation specified. Give a word starting with',
     *       ' X for X-rays or N for neutrons on line 2.')
 1002 FORMAT(/,1X,A,' radiation is used with incident angle',F6.1,
     *       ' degrees.',/)
      END

*     ***********************
      SUBROUTINE CONPRE(C,CF)
*     ***********************
*
*     This subroutine prepares the elements of the bordering matrix due
*     to the constraint functions.
*
      REAL CF(4),C(51,4)
      INCLUDE 'BLANK.FOR'
      COMMON/CONSTR/ML,LN(4),COEF(4,10),IL(4,9),JL(4,9),IQ(4,9),JQ(4,9)
      DO 10 J=1,MAXCON
      DO 10 I=1,MAXS
   10 C(I,J)=0
      DO 20 I=1,MAXCON
      CF(I)=COEF(I,10)
*
*     I chooses the constraint and J goes thru all terms in left-hand
*     side of constraint equation.
*
      LNI=LN(I)
      DO 20 J=1,LNI
*
*     For linear constraints IL(I,J) chooses category, that is,
*     instrument, crystal or atom parameter and JL(I,J) chooses the
*     particular parameter inside the category.
*     For quadratic constraints IQ(I,J) chooses the category and
*     JQ(I,J) chooses the parameter.
*     AA is the coefficient in the constraint equation.
*
      AA=COEF(I,J)
      CALL PICK(IL(I,J),JL(I,J),A,L,P)
      IF(I.LE.ML) THEN
         C(L,I)=AA*A+C(L,I)
         CF(I)=CF(I)-AA*P
      ELSE
         CALL PICK(IQ(I,J),JQ(I,J),B,M,Q)
         C(L,I)=AA*A*Q+C(L,I)
         C(M,I)=AA*B*P+C(M,I)
         CF(I)=CF(I)-AA*P*Q
      END IF
   20 CONTINUE
      RETURN
      END

*                                     Include
      LOGICAL CUBIC,FORCED,HALPER,PUNCH,STEADY,TYPE,UNIAX,XRAYS,YES
      REAL BRAGG,COSPHI,COSTHE,DISPRE,DISPIM,EQUIV,FAC,FESD,FF,FMAG,
     *     FNUC,FOBS,GEOM,RM,SCALE,SCAT,SLABDA,SMM,TEXCOR,V
      INTEGER ICENT,ICYCLE,IRL,LIM,MAXCON,MAXS,MEQ,MTYP,N,NCYCLE,NTYP
*
      COMMON/OPTION/CUBIC,FORCED,HALPER,PUNCH,STEADY,TYPE,UNIAX,XRAYS,
     *              YES
      COMMON SCALE,SLABDA,ICENT,ICYCLE,IRL,LIM,MAXCON,MAXS,N,NCYCLE,
     1MEQ(30),MTYP(30),NTYP(30),BRAGG(999),COSPHI(999),COSTHE(999),
     2DISPRE(10),DISPIM(10),EQUIV(4,3,24),FAC(999),FESD(999),FF(999,10),
     3FMAG(999),FNUC(999),FOBS(999),GEOM(999),RM(9,2,24),SCAT(10),
     4SMM(51,51),TEXCOR(999),V(51)
*                                   End include

*     *****************
      SUBROUTINE CALCUL
*     *****************
*
*     This subroutine calculates the structure factor and its
*     derivatives for reflection NQ.
*
      LOGICAL VERT
      REAL AS(3),AX(3),BS(3),BX(3),COSAR(30,24),DERIV(51),H(24,3),
     *HNN(3),RSA(30,3,3),RSAI(3,3),RSB(30,3,3),RSBI(3,3),SA(30),SB(30),
     *SINAR(30,24),SNEX(30),SNEXM(30),TEMP(30),TEXDER(15),TR(24),XI(14)
      INCLUDE 'COMMONS.FOR'
      COMMON/DERMAT/DERSTO(999,51)
      COMMON/DATA/CUT,NREFL,NH(3),IALFA,ISTAP,NCHAN,ICODE(999),
     *       HKL(3,999),SJJ(999),YOBS(15000),WEIGHT(15000),IORD(15000)
      COMMON/PARAMS/AINSTR(10),ACRYST(22), ATOM(14,30),
     *              LINSTR(10),LCRYST(22),LATOM(14,30),
     *              PINSTR(10),PCRYST(22),PATOM(14,30)
      COMMON/SPACE/JUMP,A,B,C,COSALF,COSBET,COSGAM,SINALF,SINBET,SINGAM
      SAVE
*
*     When angles in 1/10000 cycles, following statement should read
*     throughout this program:
*
*     DATA CONST/3183.09886184/ i.e. CONST = 10000/3.141592658...
      DATA CONST/11459.155903/
*                                Now CONST = 36000/3.141592658...
      DATA FACCUB/.66666666667/
*
      DATA GAUSS,TWOPI,SQRPI/0.9394372787,6.2831853072,1.7724585091/
*
*                        2 * sqrt(log 2/pi)   2 * pi       sqrt pi
*
      DATA SQRLN2/0.83255461116/,TR(1)/0.0/
*
      DO 500 NQ=1,NREFL
      DO 10 I=1,3
      HNN(I)=HKL(I,NQ)
   10 H(1,I)=HNN(I)
*
*     Calculation of q**2.
*
      QQ=PCRYST(1)*HNN(1)**2+PCRYST(2)*HNN(2)**2+PCRYST(3)*HNN(3)**2+
     *   PCRYST(4)*HNN(2)*HNN(3)+PCRYST(5)*HNN(1)*HNN(3)+
     *   PCRYST(6)*HNN(1)*HNN(2)
*
*     Overall temperature factor
*
      TAV=EXP(-PCRYST(7)*QQ/2)
*
*     Bragg's law: sin(theta)**2 = lambda**2 * q**2/4.
*
      SINTH=SLABDA*QQ
      COSTH=1-SINTH
      TANTH=SQRT(SINTH/COSTH)
*
*     BRAGG contains values of 2-theta in units specified by CONST.
*     GHALF = Gaussian halfwidth parameter.
*
      BRAGG(NQ)=CONST*ATAN(TANTH)
      GHALF=SQRT(PINSTR(3)/TANTH**2+TANTH*(PINSTR(4)*TANTH+PINSTR(5))+
     *           PINSTR(6))
*
*     Texture correction for each reflection.
*
      TEXCOR(NQ)=TEXTUR(NQ,TEXDER)
*
*     VERT = .TRUE. if asymmetry correction is to be calculated.
*
      VERT=BRAGG(NQ).LE.LIM
      DO 50 IR=2,IRL
      X=0
      DO 40 I=1,3
      Y=0
      X=EQUIV(4,I,IR)*HNN(I)+X
      DO 30 J=1,3
   30 Y=EQUIV(I,J,IR)*HNN(J)+Y
   40 H(IR,I)=Y
      TR(IR)=X
   50 CONTINUE
*
*     Calculation of COS(hx),SIN(hx) and temperature factor for
*     each atom.
*
      DO 90 I=1,N
      DO 60 J=1,14
   60 XI(J)=PATOM(J,I)
      DO 80 IR=1,IRL
      ARG=TR(IR)
      DO 70 J=1,3
   70 ARG=H(IR,J)*XI(J)+ARG
      ARG=TWOPI*ARG
      ARG2=H(IR,1)*H(IR,1)*XI( 9)+  H(IR,2)*H(IR,2)*XI(10)+
     1     H(IR,3)*H(IR,3)*XI(11)+2*H(IR,1)*H(IR,2)*XI(12)+
     2   2*H(IR,1)*H(IR,3)*XI(13)+2*H(IR,2)*H(IR,3)*XI(14)
      EXPARG=EXP(-ARG2)
      COSAR(IR,I)=COS(ARG)*EXPARG
   80 SINAR(IR,I)=SIN(ARG)*EXPARG
      TEMP(I)=EXP(-PATOM(4,I)*QQ/4)
   90 CONTINUE
*
*     Zeroize the derivatives of this reflection.
*
      DO 100 I=1,MAXS
  100 DERIV(I)=0
      IF(ICODE(NQ).EQ.2) GO TO 190
*
*     Calculate nuclear contribution to structure factor.
*
      AV=0
      BV=0
      AVIM=0
      BVIM=0
      DO 120 I=1,N
      IF(NTYP(I).EQ.0) GO TO 120
      SAI=0
      SBI=0
      DO 110 IR=1,IRL
      SAI=SAI+COSAR(IR,I)
      IF(ICENT.EQ.1) SBI=SINAR(IR,I)+SBI
  110 CONTINUE
      SAI=ICENT*SAI
      SA(I)=SAI
      SB(I)=SBI
      NI=NTYP(I)
*                                              X-rays
      IF(XRAYS.OR.ICODE(NQ).GE.4) THEN
         SNEXRE=(FF(NQ,NI)+DISPRE(NI))*PATOM(5,I)*TEMP(I)
         SNEXIM=DISPIM(NI)*PATOM(5,I)*TEMP(I)
         AVIM=SNEXIM*SAI+AVIM
         BVIM=SNEXIM*SBI+BVIM
         SNEXM(I)=2*SNEXIM*TAV
*                                              Neutrons
      ELSE
         SNEXRE=SCAT(NI)*PATOM(5,I)*TEMP(I)
         SNEXIM=0
      END IF
*
*     Calculate A and B of F
*
      AV=SNEXRE*SAI+AV
      BV=SNEXRE*SBI+BV
      SNEX(I)=2*SNEXRE*TAV
  120 CONTINUE
      FNN=(AV*AV+BV*BV+AVIM*AVIM+BVIM*BVIM)*TAV
      FNUC(NQ)=TEXCOR(NQ)*FNN
      IF(MAXS.EQ.0) GO TO 180
*
*     Nuclear contribution to derivatives - for atoms
*
      DO 160 I=1,N
      IF(NTYP(I).EQ.0) GO TO 160
      SNEXRE=SNEX(I)
      SNEXIM=SNEXM(I)
      SAI=SA(I)
      SBI=SB(I)
      DO 150 J=1,14
      K=LATOM(J,I)
      IF(K.EQ.0.OR.(J.GT.5.AND.J.LT.9)) GO TO 150
      IF(J.LE.3) THEN
*
*     Derivatives for atom coordinates - J = 1 to 3.
*
         SUMA=0
         SUMB=0
         DO 130 IR=1,IRL
         SUMA=H(IR,J)*SINAR(IR,I)+SUMA
         IF(ICENT.EQ.1) SUMB=H(IR,J)*COSAR(IR,I)+SUMB
  130    CONTINUE
         DER=-(SNEXRE*(AV*SUMA-BV*SUMB)+SNEXIM*(AVIM*SUMA-BVIM*SUMB))*
     *        ICENT*TWOPI
      ELSE IF(J.EQ.4) THEN
*
*     Derivatives for temperature factors  ---  J = 4.
*
         DER=-(SNEXRE*(AV*SAI+BV*SBI)+SNEXIM*(AVIM*SAI+BVIM*SBI))*QQ/4
      ELSE IF(J.EQ.5) THEN
*
*     Derivative for occupation number     ---  J = 5.
*
         DER=(SNEXRE*(AV*SAI+BV*SBI)+SNEXIM*(AVIM*SAI+BVIM*SBI))/
     *        PATOM(5,I)
      ELSE
*
*     Derivatives for anisotropic temperature parameters - J = 9 to 11.
*
         IF(J.LE.11) THEN
            K1=J-8
            K2=K1
         ELSE
            K1=J/14+1
            K2=J/13+2
         END IF
*
*     For the rest of the anisotropic temperature parameter -
*                                     J = 12 to 14.
*
         SUMA=0
         SUMB=0
         DO 140 IR=1,IRL
         SUMA=SUMA+H(IR,K1)*H(IR,K2)*COSAR(IR,I)
         IF(ICENT.EQ.1) SUMB=SUMB+H(IR,K1)*H(IR,K2)*SINAR(IR,I)
  140    CONTINUE
         DER=-(SNEXRE*(AV*SUMA+BV*SUMB)+SNEXIM*(AVIM*SUMA+BVIM*SUMB))*
     *        ICENT
         IF(K1.NE.K2) DER=2*DER
      END IF
      DERIV(K)=ATOM(J,I)*DER+DERIV(K)
  150 CONTINUE
  160 CONTINUE
*
*     Derivatives for - scale factor
*                     - overall temperature factor
*                     - texture parameters           - J = 8 to 22.
      K=LINSTR(2)
      IF(K.NE.0) DERIV(K)=DERIV(K)+AINSTR(2)*FNN*SCALE
      K=LCRYST(7)
      IF(K.NE.0) DERIV(K)=DERIV(K)-ACRYST(7)*FNN*QQ/2
      DO 170 J=8,22
      K=LCRYST(J)
      IF(K.NE.0) DERIV(K)=DERIV(K)+ACRYST(J)*FNN*TEXDER(J-7)
  170 CONTINUE
  180 IF(ICODE(NQ).EQ.1.OR.ICODE(NQ).GE.4) GO TO 450
*
*     Calculate magnetic contribution to structure factor and
*     derivatives.
*     For uniaxial spin configuration.
*
  190 IF(UNIAX) THEN
         X=FAC(NQ)
         FACCOS=(1+X)/2
         FACSIN=1-X
      END IF
      DO 200 I=1,3
      AX(I)=0
  200 BX(I)=0
      DO 260 I=1,N
      IF(MTYP(I).EQ.0) GO TO 260
      MEQI=MEQ(I)
      MTYPI=MTYP(I)
      SNEXRE=FF(NQ,MTYPI)*TEMP(I)*0.2695*PATOM(5,I)
      SNEX(I)=SNEXRE
      DO 220 J=1,3
      DO 220 K=1,3
      JK=(J-1)*3+K
      Y=0
      Z=0
      DO 210 IR=1,IRL
      X=RM(JK,MEQI,IR)
      Y=COSAR(IR,I)*X+Y
  210 IF(ICENT.EQ.1) Z=SINAR(IR,I)*X+Z
      RSAI(J,K)=Y
  220 RSBI(J,K)=Z
      DO 230 J=1,3
      DO 230 K=1,3
      RSAI(J,K)=RSAI(J,K)*ICENT
      RSA(I,J,K)=RSAI(J,K)
  230 RSB(I,J,K)=RSBI(J,K)
      DO 240 J=1,3
      AS(J)=0
      BS(J)=0
      DO 240 K=1,3
      AS(J)=PATOM(K+5,I)*RSAI(J,K)+AS(J)
      IF(ICENT.EQ.1) BS(J)=PATOM(K+5,I)*RSBI(J,K)+BS(J)
  240 CONTINUE
      DO 250 J=1,3
      AX(J)=AS(J)*SNEXRE+AX(J)
      IF(ICENT.EQ.1) BX(J)=BS(J)*SNEXRE+BX(J)
  250 CONTINUE
      SNEX(I)=SNEXRE*TAV
  260 CONTINUE
*
*     According to Halpern and Johnson
*
      IF(HALPER) THEN
         X=AX(1)**2+AX(2)**2+AX(3)**2+BX(1)**2+BX(2)**2+BX(3)**2+
     *     2*(COSALF*AX(2)*AX(3)+COSBET*AX(1)*AX(3)+COSGAM*AX(1)*AX(2)+
     *        COSALF*BX(2)*BX(3)+COSBET*BX(1)*BX(3)+COSGAM*BX(1)*BX(2))
         Y=(HNN(1)*AX(1)/A)**2+(HNN(2)*AX(2)/B)**2+(HNN(3)*AX(3)/C)**2+
     *     (HNN(1)*BX(1)/A)**2+(HNN(2)*BX(2)/B)**2+(HNN(3)*BX(3)/C)**2+
     *     2*HNN(1)*HNN(2)*(AX(1)*AX(2)+BX(1)*BX(2))/(A*B)+
     *     2*HNN(1)*HNN(3)*(AX(1)*AX(3)+BX(1)*BX(3))/(A*C)+
     *     2*HNN(2)*HNN(3)*(AX(2)*AX(3)+BX(2)*BX(3))/(B*C)
         FNN=X-Y/QQ
      END IF
*
*     For uniaxial spin configuration
*
      IF(UNIAX) FNN=FACSIN*(AX(3)**2+BX(3)**2)+
     *              FACCOS*(AX(1)**2+BX(1)**2+AX(2)**2+BX(2)**2+
     *                      2*COSGAM*(AX(1)*AX(2)+BX(1)*BX(2)))
*
*    For cubic spin configuration.
*
      IF(CUBIC) FNN=FACCUB*(AX(1)**2+AX(2)**2+AX(3)**2+
     *                      BX(1)**2+BX(2)**2+BX(3)**2)
*
*     Calculate magnetic structure factor.
*
      FNN=FNN*TAV
*
*     Total structure factor.
*
      FMAG(NQ)=TEXCOR(NQ)*FNN
      IF(MAXS.EQ.0) GO TO 500
*
*     Calculate derivatives.
*
      DO 300 I=1,3
      AS(I)=0
  300 BS(I)=0
      IF(HALPER) THEN
         X=2*(HNN(1)*AX(1)/A+HNN(2)*AX(2)/B+HNN(3)*AX(3)/C)/QQ
         AS(1)=2*(AX(1)+AX(2)*COSGAM+AX(3)*COSBET)-HNN(1)*X/A
         AS(2)=2*(AX(2)+AX(3)*COSALF+AX(1)*COSGAM)-HNN(2)*X/B
         AS(3)=2*(AX(3)+AX(1)*COSBET+AX(2)*COSALF)-HNN(3)*X/C
         IF(ICENT.EQ.1) THEN
            X=2*(HNN(1)*BX(1)/A+HNN(2)*BX(2)/B+HNN(3)*BX(3)/C)/QQ
            BS(1)=2*(BX(1)+BX(2)*COSGAM+BX(3)*COSBET)-HNN(1)*X/A
            BS(2)=2*(BX(2)+BX(3)*COSALF+BX(1)*COSGAM)-HNN(2)*X/B
            BS(3)=2*(BX(3)+BX(1)*COSBET+BX(2)*COSALF)-HNN(3)*X/C
         END IF
      END IF
      IF(UNIAX) THEN
         AS(1)=2*FACCOS*(AX(2)*COSGAM+AX(1))
         AS(2)=2*FACCOS*(AX(1)*COSGAM+AX(2))
         AS(3)=2*FACSIN*AX(3)
         IF(ICENT.EQ.1) THEN
            BS(1)=2*FACCOS*(BX(2)*COSGAM+BX(1))
            BS(2)=2*FACCOS*(BX(1)*COSGAM+BX(2))
            BS(3)=2*FACSIN*BX(3)
         END IF
      END IF
      IF(CUBIC) THEN
         DO 330 I=1,3
         AS(I)=2*AX(I)*FACCUB
         IF(ICENT.EQ.1) BS(I)=2*BX(I)*FACCUB
  330    CONTINUE
      END IF
*
*     Magnetic contribution to derivatives - for atoms.
*
      DO 430 I=1,N
      IF(MTYP(I).EQ.0) GO TO 430
      SNEXRE=SNEX(I)
      MEQI=MEQ(I)
      DO 420 J=1,8
      LPIJ=LATOM(J,I)
      IF(LPIJ.EQ.0) GO TO 420
      DO 340 K=1,3
      AX(K)=0
  340 BX(K)=0
*
*     Derivatives for atom coordinates - J = 1 to 3.
*
      IF(J.LE.3) THEN
         DO 370 L=1,3
         DO 360 K=1,3
         X=0
         Y=0
         DO 350 IR=1,IRL
         LM=(L-1)*3+K
         Z=RM(LM,MEQI,IR)
         X=H(IR,J)*SINAR(IR,I)*Z+X
         IF(ICENT.EQ.1) Y=H(IR,J)*COSAR(IR,I)*Z+Y
  350    CONTINUE
         AX(L)=PATOM(K+5,I)*X+AX(L)
         IF(ICENT.EQ.1) BX(L)=PATOM(K+5,I)*Y+BX(L)
  360    CONTINUE
         AX(L)=-AX(L)*SNEXRE*ICENT*TWOPI
         IF(ICENT.EQ.1) BX(L)=BX(L)*SNEXRE*TWOPI
  370    CONTINUE
*
*     Derivatives for temparature factor and occupation number -
*                                 J = 4 to 5.
      ELSE IF(J.LE.5) THEN
         DO 390 K=1,3
         DO 380 L=1,3
         AX(K)=RSA(I,K,L)*PATOM(L+5,I)+AX(K)
         IF(ICENT.EQ.1) BX(K)=RSB(I,K,L)*PATOM(L+5,I)+BX(K)
  380    CONTINUE
         AX(K)=AX(K)*SNEXRE*X1
         IF(ICENT.EQ.1) BX(K)=BX(K)*SNEXRE*X1
  390    CONTINUE
      ELSE
*
*     Derivatives for anisotropic temperature factors - J = 6 to 8.
*
         DO 400 K=1,3
         AX(K)=RSA(I,K,J-5)*SNEXRE
         IF(ICENT.EQ.1) BX(K)=RSB(I,K,J-5)*SNEXRE
  400    CONTINUE
      END IF
      DER=0
      DO 410 K=1,3
      IF(ICENT.EQ.1) THEN
         X1=BS(K)*BX(K)
      ELSE
         X1=0
      END IF
  410 DER=X1+AS(K)*AX(K)+DER
      DERIV(LPIJ)=ATOM(J,I)*DER+DERIV(LPIJ)
  420 CONTINUE
  430 CONTINUE
*
*     Derivatives for - scale factor
*                     - overall temperature factor
*                     - texture parameters           - J = 8 to 22.
      K=LINSTR(2)
      IF(K.NE.0) DERIV(K)=DERIV(K)+AINSTR(2)*FNN*SCALE
      K=LCRYST(7)
      IF(K.NE.0) DERIV(K)=DERIV(K)-ACRYST(7)*FNN*QQ/2
      DO 440 J=8,22
      K=LCRYST(J)
      IF(K.NE.0) DERIV(K)=DERIV(K)+ACRYST(J)*FNN*TEXDER(J-7)
  440 CONTINUE
  450 IF(MAXS.EQ.0) GO TO 500
*
*     Calculate derivatives for the rest of the parameters.
*     If FNN is less than 0.1 the derivatives can be approximated
*     to zero.
*
      FNN=FNUC(NQ)+FMAG(NQ)
      IF(FNN.LT.0.1) GO TO 480
*
*     Gaussian halfwidth parameter derivatives - first T, then U, V, W.
*
      X=TANTH*TANTH
      K=LINSTR(3)
      IF(K.NE.0) DERIV(K)=AINSTR(3)*FNN/(2*X*GHALF**2)+DERIV(K)
      DO 460 J=4,6
      K=LINSTR(J)
      IF(K.NE.0) DERIV(K)=X*AINSTR(J)*FNN/(2*GHALF**2)+DERIV(K)
  460 X=X/TANTH
*
*     Lorentzian halfwidth parameter derivatives.
*
      K=LINSTR(7)
      IF(K.NE.0) DERIV(K)=SQRLN2*TANTH*AINSTR(7)*FNN/GHALF+DERIV(K)
      K=LINSTR(8)
      IF(K.NE.0) DERIV(K)=SQRLN2*AINSTR(8)*FNN/(GHALF*SQRT(COSTH))+
     *                    DERIV(K)
*
*     Zeropoint derivatives and cell constant derivatives.
*
      K=LINSTR(9)
      IF(K.NE.0) DERIV(K)=AINSTR(9)*SQRPI*GAUSS*FNN/GHALF+DERIV(K)
      K=LINSTR(10)
      IF(K.NE.0) DERIV(K)=AINSTR(10)*SQRPI*GAUSS*FNN/(TANTH*GHALF)+
     *                    DERIV(K)
      DO 470 J=1,6
      K=LCRYST(J)
      IF(K.EQ.0) GO TO 470
      IF(J.LT.4) THEN
         X=HNN(J)*HNN(J)
      ELSE IF(J.EQ.4) THEN
         X=HNN(2)*HNN(3)
      ELSE IF(J.EQ.5) THEN
         X=HNN(1)*HNN(3)
      ELSE
         X=HNN(1)*HNN(2)
      END IF
      DERIV(K)=X*SLABDA*FNN*ACRYST(J)/(2*SQRT(SINTH*COSTH))+DERIV(K)
  470 CONTINUE
*
*     Asymmetry parameter derivative.
*
      K=LINSTR(1)
      IF((K.NE.0).AND.VERT) DERIV(K)=-AINSTR(1)*FNN/TANTH+DERIV(K)
*
*     Store derivatives for this reflection.
*
  480 DO 490 I=1,MAXS
  490 DERSTO(NQ,I)=DERIV(I)
  500 CONTINUE
      RETURN
      END

*     **************************
      SUBROUTINE PICK(I,J,A,L,P)
*     **************************
*
*     This subroutine picks the correct combination of parameters and
*     parameter-related items. Dummy argument 'I' specifies the
*     parameter type or group according to the following table.
*     Then 'J' picks the desired position in the arrays chosen.
*
*     -----------------------------------------
*         I      Parameter group     Range of J
*     -----------------------------------------
*         1      Instrument            1 ... 10
*         2      Crystal               1 ... 22
*         3      Atom 1                1 ... 14
*         4      Atom 2                1 ... 14
*         5      Atom 3                1 ... 14
*         .        .                      .
*         .        .                      .
*         .        .                      .
*     -----------------------------------------
      COMMON/PARAMS/AINSTR(10),ACRYST(22), ATOM(14,30),
     *              LINSTR(10),LCRYST(22),LATOM(14,30),
     *              PINSTR(10),PCRYST(22),PATOM(14,30)
*
      IF(I.EQ.1) THEN
         IF(J.LE.0.OR.J.GT.10) GO TO 10
         A=AINSTR(J)
         L=LINSTR(J)
         P=PINSTR(J)
      ELSE IF(I.EQ.2) THEN
         IF(J.LE.0.OR.J.GT.22) GO TO 10
         A=ACRYST(J)
         L=LCRYST(J)
         P=PCRYST(J)
      ELSE
         IF(J.LE.0.OR.J.GT.14) GO TO 10
         A= ATOM(I-2,J)
         L=LATOM(I-2,J)
         P=PATOM(I-2,J)
      END IF
      IF(L.GT.0) RETURN
*
*     L cannot be zero because it is used as an array index in CONPRE.
*     J must also be inside specified range.
*
   10 WRITE(6,1000) I,J,L
      STOP
 1000 FORMAT(' In PICK: I, J and L are:',3I4,'. Something is wrong',
     *       ' in constraint function input.')
      END

*     ******************
      FUNCTION DTSLIN(L)
*     ******************
*
*     DTSLIN solves the matrix equation SMM*X=V for X and stores the
*     result X in V. The size of the system is L, where L.LE.51.
*
      REAL Q(51),U(51)
      INTEGER M(51)
      INCLUDE 'BLANK.FOR'
      SAVE
*
      DO 20 I=1,L
      Z=0
      DO 10 J=1,L
      D=1.0E-8*SMM(I,J)
   10 Z=D*D+Z
      Q(I)=SQRT(1.0E8*Z)
   20 U(I)=Q(I)
      DO 40 I=1,L
      Z=1/U(I)
      DO 30 J=1,L
   30 SMM(J,I)=SMM(J,I)*Z
   40 CONTINUE
      E=0
      DO 90 K=1,L
      R=-1
      DO 60 I=K,L
      Z=0
      DO 50 J=1,K-1
      Z=SMM(I,J)*SMM(J,K)+Z
   50 CONTINUE
      SMM(I,K)=SMM(I,K)-Z
      S=ABS(SMM(I,K)/Q(I))
      IF(S.GT.R) THEN
         R=S
         M(K)=I
      END IF
   60 CONTINUE
      KP=M(K)
      Q(KP)=Q(K)
      DO 80 J=1,L
      R=SMM(K,J)
      IF(J.LE.K) THEN
         KP=M(K)
         SMM(K,J)=SMM(KP,J)
      ELSE
         Z=0
         DO 70 I=1,K-1
         Z=SMM(K,I)*SMM(I,J)+Z
   70    CONTINUE
         KP=M(K)
         SMM(K,J)=(SMM(KP,J)-Z)/SMM(K,K)
      END IF
      KP=M(K)
      IF(KP.NE.K) SMM(KP,J)=-R
   80 CONTINUE
      E=E+ALOG10(ABS(SMM(K,K)))
   90 CONTINUE
      DTSLIN=E
      DO 110 K=1,L
      R=V(K)
      Z=0
      DO 100 I=1,K-1
      Z=SMM(K,I)*V(I)+Z
  100 CONTINUE
      KP=M(K)
      V(K)=(V(KP)-Z)/SMM(K,K)
      IF(KP.NE.K) V(KP)=-R
  110 CONTINUE
      DO 130 K=L,1,-1
      Z=0
      DO 120 I=K+1,L
      Z=SMM(K,I)*V(I)+Z
  120 CONTINUE
      V(K)=V(K)-Z
  130 CONTINUE
      DO 190 K=L,1,-1
      DO 140 J=K+1,L
      Q(J)=SMM(K,J)
      SMM(K,J)=0
  140 CONTINUE
      SMM(K,K)=1/SMM(K,K)
      DO 160 J=K-1,1,-1
      Z=0
      DO 150 I=J+1,K
      Z=SMM(K,I)*SMM(I,J)+Z
  150 CONTINUE
      SMM(K,J)=-Z/SMM(J,J)
  160 CONTINUE
      DO 180 J=1,L
      Z=0
      DO 170 I=K+1,L
      Z=Q(I)*SMM(I,J)+Z
  170 CONTINUE
      SMM(K,J)=SMM(K,J)-Z
  180 CONTINUE
  190 CONTINUE
      DO 210 K=L,1,-1
      IF(M(K).EQ.K) GO TO 210
      DO 200 I=1,L
      R=SMM(I,K)
      KP=M(K)
      SMM(I,K)=-SMM(I,KP)
      SMM(I,KP)=R
  200 CONTINUE
  210 CONTINUE
      DO 230 I=1,L
      V(I)=V(I)/U(I)
      DO 220 J=1,L
      SMM(I,J)=SMM(I,J)/U(I)
  220 CONTINUE
  230 CONTINUE
      RETURN
      END

*     **********************
      SUBROUTINE SORT(A,L,N)
*     **********************
*
*     The subroutine SORT applies to the array A with J elements.
*     The indices of the ordered array are placed in array L to
*     obtain the ordered array replace the indices I of A(I) with
*     I = L(I) - REF. CACM 271.
*
      DIMENSION A(300),L(300),IUT(10),ILT(10)
      J=N
      I=1
      M=1
      DO 10 K=1,J
   10 L(K)=K
   20 IF(J.LE.I-1) GO TO 60
      IP=(J+I)/2
      ITT=L(IP)
      T=A(ITT)
      L(IP)=L(I)
      IQ=J
      K=I+1
   30 IF(K.GT.IQ) GO TO 50
      LK=L(K)
      IF(A(LK).LE.T) THEN
         K=K+1
         GO TO 30
      END IF
   40 IF(IQ.LT.K) THEN
         IQ=K-1
         GO TO 50
      END IF
      LQ=L(IQ)
      IF(A(LQ).LT.T) THEN
         IX=L(K)
         L(K)=L(IQ)
         L(IQ)=IX
         IQ=IQ-1
         K=K+1
         GO TO 30
      END IF
      IQ=IQ-1
      GO TO 40
   50 L(I)=L(IQ)
      L(IQ)=ITT
      IF(2*IQ.GT.I-J) THEN
         ILT(M)=I
         IUT(M)=IQ-1
         I=IQ+1
      ELSE
         ILT(M)=IQ+1
         IUT(M)=J
         J=IQ-1
      END IF
      M=M+1
      GO TO 20
   60 IF(I.LT.J) THEN
         LI=L(I)
         LJ=L(J)
         IF(A(LI).GT.A(LJ)) THEN
            IX=L(I)
            L(I)=L(J)
            L(J)=IX
         END IF
      END IF
      M=M-1
      IF(M.GT.0) THEN
         I=ILT(M)
         J=IUT(M)
         GO TO 20
      END IF
      RETURN
      END

*     ***********************
      SUBROUTINE COORD(HKL,I)
*     ***********************
      INTEGER I
      REAL HKL(3)
*
*     This subroutine sets the correct cartesian coordinate orientation
*     according to space symmetry.
*     Cell dimensions in /SPACE/ and Miller indices H, K and L for
*     reflection I are used. JUMP specifies the symmetry.
*
      INTEGER JUMP
      REAL H,K,L
      REAL A,B,C,COSALF,COSBET,COSGAM,SINALF,SINBET,SINGAM
      INCLUDE 'BLANK.FOR'
      COMMON/SPACE/JUMP,A,B,C,COSALF,COSBET,COSGAM,SINALF,SINBET,SINGAM

      H=HKL(1)
      K=HKL(2)
      L=HKL(3)
*
*     Branch according to the structure
*
      GO TO (10,20,30,30,30,60,60,80,80,80,80,120,120),JUMP
      GO TO 150
*
*     Triclinic         -- Space groups 1   ...   2
*
  10  S11=(B*C*SINALF)**2
      S12=A*B*C*C*(COSALF*COSBET-COSGAM)
      S22=(A*C*SINBET)**2
      S33=(A*B*SINGAM)**2
      S23=A*A*B*C*(COSBET*COSGAM-COSALF)
      S13=A*B*B*C*(COSGAM*COSALF-COSBET)
*
      D=SQRT(S33*(S11*H*H+S22*K*K+S33*L*L+2*(S23*K*L+S13*H*L+S12*H*K)))
      CT=(S33*L+S23*K+S13*H)/D
      D=SQRT(S11*(S11*H*H+S22*K*K+2*S12*H*K))
      CP=(S11*H+S12*K)/D
      GO TO 140
*
*     Monoclinic        -- Space groups 3   ...  15  -  b-axis unique
*
  20  D=(H/A)**2+(L/C)**2-2*H*L*COSBET/(A*C)
      IF(D.EQ.0) THEN
         CP=1
      ELSE
         CP=(H/A-L*COSBET/C)/SQRT(D)
      END IF
      CT=K*SINBET/(B*SQRT(D+(K*SINBET/B)**2))
      GO TO 140
*
*     Orthorhombic      -- Space groups 16  ...  74
*
  30  D=SQRT((H/A)**2+(K/B)**2+(L/C)**2)
      IF(JUMP.EQ.3) THEN
*                                  Case A: a-axis unique
         CT=H/(A*D)
         OVER=K/B
         UNDER=SQRT((K/B)**2+(L/C)**2)
      ELSE IF(JUMP.EQ.4) THEN
*                                  Case B: b-axis unique
         CT=K/(B*D)
         OVER=L/C
         UNDER=SQRT((H/A)**2+(L/C)**2)
*                                  Case C: c-axis unique
      ELSE
         CT=L/(C*D)
         OVER=H/A
         UNDER=SQRT((H/A)**2+(K/B)**2)
      END IF
      IF(UNDER.EQ.0) THEN
         CP=1
      ELSE
         CP=OVER/UNDER
      END IF
      GO TO 140
*
*     Tetragonal          -- Space groups 75  ... 142
*
   60 D=SQRT((H*H+K*K)/(A*A)+(L/C)**2)
      CT=L/(C*D)
      IF(H*H+K*K.EQ.0) THEN
         CP=1
      ELSE
         CP=H/SQRT(H*H+K*K)
      END IF
      GO TO 140
*
*     Trigonal            -- Space groups 143 ... 167
*     Hexagonal           -- Space groups 168 ... 194
*
   80 D=H*H+K*K+H*K
      CT=0.8660254038*A*L/(C*SQRT(D+3*(A*L/(2*C))**2))
      IF(D.EQ.0) THEN
         CP=1
      ELSE
         CP=(H+0.5*K)/SQRT(D)
      END IF
      GO TO 140
*
*     Cubic               -- Space groups 195 ... 230
*
  120 D=H*H+K*K
      CT=L/SQRT(D+L*L)
      IF(D.EQ.0) THEN
         CP=1
      ELSE
         CP=H/SQRT(D)
      END IF
*
*     Get rid of rounding errors.
*
  140 IF(ABS(CT).GT.1) CT=SIGN(1.0,CT)
      IF(ABS(CP).GT.1) CP=SIGN(1.0,CP)
      COSTHE(I)=CT
      COSPHI(I)=CP
      RETURN
  150 WRITE(6,1000) JUMP
      STOP
 1000 FORMAT(' In COORD: Invalid symmetry; JUMP =',I5,'.')
      END

      PROGRAM REFINE
************************************************************************
*         P R O F I L E   R E F I N E M E N T   P R O G R A M          *
*======================================================================*
*                       Version  3-JAN-1989                            *
*                                                                      *
************************************************************************
*************************  H I S T O R Y  ******************************
************************************************************************
*                  H. M. Rietveld - December 1970.                     *
************************************************************************
*    Modified December 1972 for anisotropic temperature factors by     *
*    A. W. Hewat, UKAERE Harwell, Didcot, Berkshire, England.          *
************************************************************************
*    Modified for Voigtian shape function on 1983 by M. Nurmela,       *
*    University of Helsinki.                                           *
************************************************************************
*    Modified June 1986 for x-ray data by M. Nurmela,                  *
*    Imatran Voima Oy, Helsinki                                        *
************************************************************************
*    Modified July 1986 by M. Nurmela, Imatran Voima Oy, Helsinki      *
*    The concept 'number of overlapping reflections' is obsolete.      *
************************************************************************
*    Modified July 1987 by M. Nurmela, Imatran Voima Oy, Helsinki      *
*    Texture correction is changed according to M.Jarvinen.
*    Preparation program attached as a subroutine.                     *
************************************************************************
*    Modified january 1989 by M. Nurmela, Imatran Voima Oy, Helsinki   *
*    A reference to the theory of texture correction is given. No      *
*    changes in code between versions 8-OCT-1987 and 3-JAN-1989.       *
************************************************************************
*                         VARIABLE DIMENSIONS                          *
*                         -------------------                          *
*           B=MAXIMUM NUMBER OF BACKGROUND POSITIONS                   *
*           R=MAXIMUM NUMBER OF EQUIVALENT POSITIONS + 1               *
*           K=MAXIMUM NUMBER OF SCATTERING LENGTHS                     *
*           F=MAXIMUM NUMBER OF FORMFACTORS                            *
*           N=MAXIMUM NUMBER OF ATOMS                                  *
*           M=MAXIMUM NUMBER OF MAGNETIC ROTATION MATRICES             *
*           P=MAXIMUM NUMBER OF LEAST SQUARES PARAMETERS               *
*           C=MAXIMUM NUMBER OF CONSTRAINT FUNCTIONS                   *
*           T=MAXIMUM NUMBER OF TERMS IN CONSTRAINT FUNCTION           *
*           I=MAXIMUM NUMBER OF REFLECTIONS                            *
*           L=MAXIMUM NUMBER OF EXCLUDED REGIONS                       *
*           X=MAXIMUM NUMBER OF PROFILE INTENSITIES                    *
*          PC=P+C                                                      *
*                                   *****                              *
*                      Arrays with variable dimensions                 *
*                      -------------------------------                 *
*          ICODE(I)            IH(3,I)             IHIGH(L)            *
*          IL(C,T)             INDEX(I)            IORD(X)             *
*          IQ(C,T)             JCODE(I)            JL(C,T)             *
*          JQ(C,T)             LL(I)               LN(C)               *
*          LOW(L)              M(I)                MEQ(N)              *
*          MTYP(N)             NTYP(N)             ATEXT(N)            *
*          BAK(B)              BRAGG(I)            C(C,PC)             *
*          CF(C)               COEF(C,T)           COSAR(R,N)          *
*          COSTHE(I)           COSPHI(I)           DERIV(PC)           *
*          DERSTO(I,PC)        DF(C)               DISPIM(K)           *
*          DISPRE(K)           DUMP(I)             EQUIV(4,3,R)        *
*          F(21,F)             FAC(I)              FESD(I)             *
*          FF(I,F)             FMAG(I)             FNUC(I)             *
*          FOBS(I)             H(R,3)              HKL(3,I)            *
*          HW(I)               PLOR(I)             POS(B)              *
*          RM(9,M,R)           RSA(N,3,3)          RSB(N,3,3)          *
*          S(21,F)             SA(N)               SB(N)               *
*          SCAT(K)             SINAR(R,N)          SJJ(I)              *
*          SMM(PC,PC)          SNEX(N)             SOMEGA(I)           *
*          SZ(6,N)             T(I)                TEMP(N)             *
*          TEXCOR(I)           TL(I)               TR(R)               *
*          V(PC)               WEIGHT(X)                               *
************************************************************************
*                            ******************                        *
*                            * PRESENT VALUES *                        *
*                            *      R =   24  *                        *
*                            *      K =   10  *                        *
*                            *      F =   10  *                        *
*                            *      N =   30  *                        *
*                            *      M =    2  *                        *
*                            *      P =   47  *                        *
*                            *      C =    4  *                        *
*                            *      PC=   51  *                        *
*                            *      I =  999  *                        *
*                            *      T =    9  *                        *
*                            *      B =  100  *                        *
*                            *      L =   10  *                        *
*                            *      X =15000  *                        *
*                            ******************                        *
*               *****************************************              *
*               *   UNIT  3 = Raw measurement data      *              *
*               *   UNIT  5 = Standard input            *              *
*               *   UNIT  6 = Standard output           *              *
*               *   UNIT  7 = Disk file for reflection  *              *
*               *             output                    *              *
*               *   UNIT  8 = Disk file for profile     *              *
*               *             output                    *              *
*               *   UNIT 13 = Output file for observed  *              *
*               *             and calculated profile    *              *
*               *   UNIT 18 = Output file for observed  *              *
*               *             and calculated structure  *              *
*               *             factors.                  *              *
*               *****************************************              *
*                                                                      *
************************************************************************
*             PARAMETER NAME CONVENTIONS IN THIS PROGRAM               *
*                                                                      *
*      1.          Instrument dependent parameters                     *
*      --          -------------------------------                     *
*                                                                      *
*               PINSTR(1)  = Asymmetry parameter                       *
*               PINSTR(2)  = Overall scale factor                      *
*               PINSTR(3)  = Gaussian halfwidth parameter T            *
*               PINSTR(4)  = Gaussian halfwidth parameter U            *
*               PINSTR(5)  = Gaussian halfwidth parameter V            *
*               PINSTR(6)  = Gaussian halfwidth parameter W            *
*               PINSTR(7)  = Lorentzian halfwidth parameter X          *
*               PINSTR(8)  = Lorentzian halfwidth parameter Y          *
*               PINSTR(9)  = Zeropoint parameter Z                     *
*               PINSTR(10) = Zeropoint parameter S                     *
*----------------------------------------------------------------------*
*                                                                      *
*      2.          Structure dependent parameters                      *
*      --          ------------------------------                      *
*                                                                      *
*               PCRYST(1)  = Cell constant A in the equation below     *
*                  .                    .                              *
*                  .                    .                              *
*                  .                    .                              *
*               PCRYST(6)  = Cell constant F in the equation below     *
*               PCRYST(7)  = Overall temperature factor                *
*               PCRYST(8)  = Texture parameter #1                      *
*               PCRYST(9)  = Texture parameter #2                      *
*                  .                    .                              *
*                  .                    .                              *
*                  .                    .                              *
*               PCRYST(22) = Texture parameter #15                     *
*                                                                      *
* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*
*        1/d**2 = A*h**2 + B*k**2 + C*l**2 + D*k*l + E*h*l + F*h*k     *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*      3.                Atom parameters                               *
*      --                ---------------                               *
*                                                                      *
*               PATOM(1)   = Fractional atomic coordinate x            *
*               PATOM(2)   = Fractional atomic coordinate y            *
*               PATOM(3)   = Fractional atomic coordinate z            *
*               PATOM(4)   = Isotropic atomic temperature factor B     *
*               PATOM(5)   = Occupation number                         *
*               PATOM(6)   = Magnetic vector component K(x)            *
*               PATOM(7)   = Magnetic vector component K(y)            *
*               PATOM(8)   = Magnetic vector component K(z)            *
*               PATOM(9)   = Anisotropic temperature factor B(11)      *
*               PATOM(10)  = Anisotropic temperature factor B(22)      *
*               PATOM(11)  = Anisotropic temperature factor B(33)      *
*               PATOM(12)  = Anisotropic temperature factor B(12)      *
*               PATOM(13)  = Anisotropic temperature factor B(13)      *
*               PATOM(14)  = Anisotropic temperature factor B(23)      *
*                                                                      *
************************************************************************
*                                                                      *
      INCLUDE 'COMMONS.FOR'
*
*     Read the data and check for proper initialization.
*
      CALL INPUT
      ICYCLE=0
      FORCED=.FALSE.
    1 ICYCLE=ICYCLE+1
      IF(ICYCLE.GT.NCYCLE) GO TO 2
*
*     Take a new iteration step.
*
      CALL ITER
      GO TO 1
*
*     After the final cycle the results are written on disk files
*     if certain options are set.
*
    2 CALL EXPUT
      END
*     ******************
      FUNCTION APPROX(Y)
*     ******************
*
*     This function gives the value of expression
*
*     (1 + A*Y + B*Y**2)/(1 + C*Y + D*Y**2) .
*
      DATA A,B,C,D/0.903964515,0.769954808,1.36421616,1.13619508/
*
      APPROX=(1 + (A + B*Y)*Y)/(1 + (C + D*Y)*Y)
      RETURN
      END
      INCLUDE 'CALCUL.FOR'
*     *********************
      FUNCTION CODING(X,LP)
*     *********************
      LP=INT(ABS(X))/10
      CODING=(ABS(X)-10*LP)*SIGN(1.0,X)
      RETURN
      END
      INCLUDE 'CONPRE.FOR'
      INCLUDE 'COORD.FOR'
      INCLUDE 'CUBHAR.FOR'
*     *************************
      COMPLEX FUNCTION CWERF(Z)
*     *************************
*
*     Gautschi's algorithm for evaluating complex error function
*     for complex argument Z.
*
      COMPLEX VALUE,Z
      REAL LAMBDA
      LOGICAL B
      SAVE
*
*     TWOPI = 2/Sqrt(Pi)
*
      DATA TWOPI/1.12837 91671/
*
      XX=REAL(Z)
      YY=AIMAG(Z)
      X=ABS(XX)
      Y=ABS(YY)
      IF(Y .GE. 4.29 .OR. X .GE. 5.33) THEN
         H=0
         NC=0
         NU=8
         LAMBDA=0
         B=.TRUE.
      ELSE
         S=(1 - Y/4.29)*SQRT(1 - X*X/28.41)
         H=1.6*S
         H2=2*H
         NC=6+INT(23*S)
         NU=9+INT(21*S)
         LAMBDA=H2**NC
         B= LAMBDA .EQ. 0
      END IF
      R1=0
      R2=0
      S1=0
      S2=0
      N=NU+1
    3 N=N-1
      FN=N+1
      T1=Y+H+FN*R1
      T2=X-FN*R2
      C=0.5/(T1*T1+T2*T2)
      R1=C*T1
      R2=C*T2
      IF(H .LE. 0 .OR. N .GT. NC) GO TO 4
      T1=LAMBDA+S1
      S1=R1*T1-R2*S2
      S2=R2*T1+R1*S2
      LAMBDA=LAMBDA/H2
    4 IF(N .GT. 0) GO TO 3
      IF(B) THEN
         RS1=R1
         RS2=R2
      ELSE
         RS1=S1
         RS2=S2
      END IF
      RS1=TWOPI*RS1
      IF(Y .EQ. 0) RS1=EXP(-X*X)
      VALUE=CMPLX(RS1,TWOPI*RS2)
      IF(YY .GE. 0) THEN
         IF(XX .LT. 0) VALUE=CONJG(VALUE)
      ELSE
         VALUE=2*CEXP(-CMPLX(X,Y)**2)-VALUE
         IF(XX .GT. 0) VALUE=CONJG(VALUE)
      END IF
      CWERF=VALUE
      RETURN
      END
      INCLUDE 'DIRECT.FOR'
      INCLUDE 'DTSLIN.FOR'
*     *******************
      FUNCTION ERROR(A,B)
*     *******************
*
*     This function calculates the ESD of a function of 6 variables of
*     which the covariance matrix A and their derivatives B are given.
*
      REAL A(6,6),B(6)
      SUM=0
      DO 1 I=1,6
      DO 1 J=I,6
      X=2
      IF(I.EQ.J) X=1
    1 SUM=SUM+A(I,J)*B(I)*B(J)*X
      IF(SUM.LT.0) SUM=0
      ERROR=SQRT(SUM)
      RETURN
      END
*     ********************
      SUBROUTINE ESD(SM,V)
*     ********************
*
*     This subroutine calculates the E.S.D of the direct cell dimensions
*     from the inverse normal matrix SM and from the cell constants V.
*
      REAL SM(6,6),V(6),S(6),R(6),E(6)
      SAVE
      DATA DEGR/57.295779513/
*
      I=0
      DO 1 IA=1,3
      I=I+1
      IB=MOD(IA,3)+1
      IC=MOD(IA+1,3)+1
      ID=IA+3
      IE=IB+3
      IP=IC+3
      FNUM=4*V(IB)*V(IC)-V(ID)*V(ID)
      DEN=4*V(IA)*V(IB)*V(IC)-V(IA)*V(ID)*V(ID)-V(IB)*V(IE)*V(IE)-V(IC)
     1   *V(IP)*V(IP)+V(ID)*V(IE)*V(IP)
      S(I)=SQRT(FNUM/DEN)
      R(IA)=-S(I)**4
      DENL=1/(DEN*DEN)
      R(IB)=DENL*(4*V(IC)*DEN-(4*V(IA)*V(IC)-V(IE)*V(IE))*FNUM)
      R(IC)=DENL*(4*V(IB)*DEN-(4*V(IA)*V(IB)-V(IP)*V(IP))*FNUM)
      R(ID)=-DENL*(2*V(ID)*DEN-(2*V(IA)*V(ID)-V(IE)*V(IP))*FNUM)
      R(IE)=DENL*FNUM*(2*V(IB)*V(IE)-V(ID)*V(IP))
      R(IP)=DENL*FNUM*(2*V(IC)*V(IP)-V(ID)*V(IE))
      E(I)=ERROR(SM,R)
      E(I)=E(I)/(2*S(I))
      FNUM=V(IE)*V(IP)-2*V(IA)*V(ID)
      DEN=16*V(IA)*V(IA)*V(IB)*V(IC)+V(IE)*V(IE)*V(IP)*V(IP)-
     1    4*(V(IA)*V(IB)*V(IE)*V(IE)+V(IC)*V(IA)*V(IP)*V(IP))
      DENL=1/(DEN*DEN)
      FNUML=FNUM*FNUM
      S(I+3)=FNUML/DEN
      R(IA)=-4*FNUM*DENL*(V(ID)*DEN+FNUM*(8*V(IA)*V(IB)*V(IC)-
     1      V(IB)*V(IE)*V(IE)-V(IC)*V(IP)*V(IP)))
      R(IB)=-4*FNUML*DENL*(4*V(IA)*V(IA)*V(IC)-V(IA)*V(IE)*V(IE))
      R(IC)=-4*FNUML*DENL*(4*V(IA)*V(IA)*V(IB)-V(IA)*V(IP)*V(IP))
      R(ID)=-4*FNUM/DEN*V(IA)
      R(IE)=2*FNUM*DENL*(V(IP)*DEN-FNUM*(V(IE)*V(IP)*V(IP)-
     1      4*V(IA)*V(IB)*V(IE)))
      R(IP)=2*FNUM*DENL*(V(IE)*DEN-FNUM*(V(IE)*V(IE)*V(IP)-
     1      4*V(IC)*V(IA)*V(IP)))
      E(I+3)=ERROR(SM,R)
      IF(S(I+3).NE.0) THEN
         E(I+3)=E(I+3)/(2*SQRT(S(I+3)*(1-S(I+3))))*DEGR
         S(I+3)=ATAN(SQRT((1-S(I+3))/S(I+3)))*DEGR
      ELSE
         S(I+3)=90
         E(I+3)=0
      END IF
      IF(FNUM.LT.0) S(I+3)=180-S(I+3)
      IF(SM(ID,ID).EQ.0) E(ID)=0
    1 CONTINUE
      IF(ABS(S(1)-S(2)).LT.0.00008) E(1)=E(2)
      DO 2 I=1,6
      SM(I,I)=E(I)
    2 V(I)=S(I)
      RETURN
      END
*     ******************
      FUNCTION EXPERF(X)
*     ******************
*
*     This routine evaluates function EXP(X*X)*ERFC(X) with relative
*     error less than 1.3E-9 for negative X and less than 3.3E-11 for
*     positive x.
*
      T=1.0-7.5/(ABS(X)+3.75)
      Y=T*(+1.0260431255E-1+T*(-5.4802326329E-2+
     C  T*(+2.4143218599E-2+T*(-8.2206241220E-3+
     D  T*(+1.8029906156E-3+T*(-2.5522236047E-5+
     E  T*(-1.5254648703E-4+T*(+4.7864583725E-5+
     F  T*(+3.7322348606E-6+T*(-6.1287297159E-6+
     G  T*(+5.9065541351E-7+T*(+6.0603869357E-7+
     H  T*(-8.6338434635E-8+T*(-4.2166157960E-8))))))))))))))
      Y=   +1.4558972128E-1+T*(-2.7342193150E-1+
     A  T*(+2.2600806690E-1+T*(-1.6357189555E-1+Y)))
      EXPERF=Y
      IF(X.LT.0) EXPERF=2*EXP(X*X)-Y
      RETURN
      END
      INCLUDE 'EXPUT.FOR'
      INCLUDE 'GEOMET.FOR'
      INCLUDE 'GROUP.FOR'
      INCLUDE 'INPUT.FOR'
      INCLUDE 'ITER.FOR'
      INCLUDE 'MATRIX.FOR'
      INCLUDE 'PICK.FOR'
      INCLUDE 'PREPAR.FOR'
*     *****************
      SUBROUTINE PROFIL
*     *****************
*
*     This subroutine assigns the adjusted values to the profile
*     parameters and calculates direct cell dimensions from the cell
*     constants.
*
      INCLUDE 'BLANK.FOR'
      COMMON/PARAMS/AINSTR(10),ACRYST(22), ATOM(14,30),
     *              LINSTR(10),LCRYST(22),LATOM(14,30),
     *              PINSTR(10),PCRYST(22),PATOM(14,30)
      COMMON/SPACE/JUMP,A,B,C,COSALF,COSBET,COSGAM,SINALF,SINBET,SINGAM
      SAVE
*
      AINV=SQRT(PCRYST(1))
      BINV=SQRT(PCRYST(2))
      CINV=SQRT(PCRYST(3))
      AF=PCRYST(4)/(2*BINV*CINV)
      BF=PCRYST(5)/(2*AINV*CINV)
      CF=PCRYST(6)/(2*AINV*BINV)
      T1=PCRYST(1)*PCRYST(2)*PCRYST(3)
      T2=PCRYST(4)*PCRYST(5)*PCRYST(6)
      T3=PCRYST(1)*PCRYST(4)**2+
     *   PCRYST(2)*PCRYST(5)**2+
     *   PCRYST(3)*PCRYST(6)**2
      VL=SQRT(T1+(T2-T3)/4)
      T1=SQRT(1-AF**2)
      T2=SQRT(1-BF**2)
      T3=SQRT(1-CF**2)
*
*     Direct cell constants.
*
      A=BINV*CINV*T1/VL
      B=AINV*CINV*T2/VL
      C=AINV*BINV*T3/VL
      COSALF=(BF*CF-AF)/(T2*T3)
      COSBET=(AF*CF-BF)/(T1*T3)
      COSGAM=(AF*BF-CF)/(T1*T2)
      SINALF=SQRT(1-COSALF**2)
      SINBET=SQRT(1-COSBET**2)
      SINGAM=SQRT(1-COSGAM**2)
      RETURN
      END
*     ****************************************************************
      SUBROUTINE READER(UNIT,CHARS,KCHAR,REALS,KREAL,INTS,KINT,OPTION)
*     ****************************************************************
*
*     This subroutine works like a free format read statement with
*     following restrictions and extensions:
*
*     Restrictions:
*     -------------
*     A) Blanks may mean zero numbers but the rest of that line
*        must consist of zeros, blanks, commas or tabs.
*     B) If a line is blank or the end of it is blanks, all numbers
*        ment to be on that line or on part of it will become zeros.
*        Search is not continued on next line(s)!
*
*     Extensions:
*     -----------
*     A) Character texts may not be included between apostrophes
*     B) Real numbers may be given without a decimal point
*     C) Real numbers given in case where integers are needed,
*        are ROUNDED to nearest integer (e.g. -5.9 is -6)
*
      CHARACTER*(*) CHARS
      INTEGER KCHAR,KREAL,KINT,INTS(1),UNIT
      REAL REALS(1)
      LOGICAL OPTION
*
      CHARACTER*80 LINE,STORE,WORK,BLANK*1,COMMA*1,TAB*1,FMT*22
      INTEGER I,K,L,LENGTH,M
      REAL RESULT(20)
      SAVE
      DATA BLANK,COMMA,TAB/' ',',','	'/
*
      FMT='(F??.0)'
*
*                        A new line is read if so desired.
*
      IF(OPTION) THEN
         READ(UNIT,'(A)') LINE
         LENGTH=80
*
*                        Replace tabs with blanks
*
   10    I=INDEX(LINE,TAB)
         IF(I .GT. 0) THEN
            LINE(I:I)=BLANK
            GO TO 10
         END IF
*
*                        Replace commas with blanks
*
   20    I=INDEX(LINE,COMMA)
         IF(I .GT. 0) THEN
            LINE(I:I)=BLANK
            GO TO 20
         END IF
      STORE=LINE
      END IF
*
*                        Remove leading blanks
*
      I=1
   30 IF(LINE(I:I) .EQ. BLANK) THEN
         I=I+1
         IF(I .LT. 80) GO TO 30
      END IF
      WORK=LINE(I:LENGTH)
      LINE=WORK
      LENGTH=LENGTH-I+1
*
*                        Extract character part if existing
*
      IF(KCHAR.GT.0) THEN
         READ(LINE,'(A)') CHARS
         L=LEN(CHARS)
         WORK=LINE(L+1:80)
         LINE=WORK
         LENGTH=80-L
      END IF
*
*                        Search for all numbers wanted
*
      DO 50 M=1,KREAL+KINT
      RESULT(M)=0
      DO 40 I=1,LENGTH
      IF(LINE(I:I) .EQ. BLANK) GO TO 40
*
*                        A non-blank character was found.
*                        Search for next blank after it.
*
      WORK=LINE(I:LENGTH)
      LENGTH=LENGTH-I+1
      K=INDEX(WORK,BLANK)
      IF(K .LT. 2) GO TO 80
*
*                        Next blank was found on position K.
*                        Read the number before it.
*
      WRITE(FMT(3:4),'(I2)') K-1
      READ(LINE(I:I+K-2),FMT,ERR=90) RESULT(M)
      LINE=WORK(K:LENGTH)
      LENGTH=LENGTH-K+1
      GO TO 50
   40 CONTINUE
   50 CONTINUE
*
*                        All numbers are found. Copy them
*                        to proper arrays.
      DO 60 I=1,KREAL
   60 REALS(I)=RESULT(I)
      DO 70 I=1,KINT
   70 INTS(I)=NINT(RESULT(I+KREAL))
      RETURN
*
*                        Error: a line without blanks was found!
*
   80 WRITE(6,1000)
      STOP
*
*                        Error: Write the erroneous line out
*                               and mark the position where the
*                               error was encountered.
*
   90 WRITE(6,2000) ('1234567890',K=1,8),STORE
      FMT='(??X,''^'',/,1X,??(''=''))'
      WRITE(FMT(2:3),'(I2)') 96-LENGTH
      WRITE(FMT(15:16),'(I2)') 96-LENGTH
      WRITE(6,FMT)
      STOP
 1000 FORMAT(' No blanks on the line!')
 2000 FORMAT(16X,8A10,/,' Error in line: ',A)
      END
      INCLUDE 'SORT.FOR'
*     **************************
      FUNCTION STEP(RELAX,X,K,Z)
*     **************************
      INCLUDE 'BLANK.FOR'
      IF(K.NE.0) THEN
         STEP=V(K)*X*RELAX
         Z=SQRT(SMM(K,K))*ABS(X)
      ELSE
         STEP=0
         Z=0
      END IF
   10 RETURN
      END
      INCLUDE 'TEXTUR.FOR'
      INCLUDE 'TIMES.FOR'
      INCLUDE 'UPDATE.FOR'
      INCLUDE 'Y.FOR'

*     ***********************
      SUBROUTINE MATRIX(SKEW)
*     ***********************
*
*     This subrouting borders the normal matrix with the constraint
*     functions, inverts this enlarged matrix and solves the system.
*
      REAL CF(4),C(51,4)
      INTEGER KS(20)
      INCLUDE 'COMMONS.FOR'
      COMMON/IO/EPS,RELAX,RELAXB,RELAXC,SUMOBS,SUMW,SUMWBS,SW,IPONS,
     *          LMAT,LOUT,NUM
      SAVE
*
      DO 10 I=1,MAXS
      DO 10 J=I+1,MAXS
   10 SMM(J,I)=SMM(I,J)
*
*     Border the matrix and enlarge the vector.
*
      IF(MAXCON.GT.0) THEN
         CALL CONPRE(C,CF)
         DO 20 I=1,MAXCON
         IMAXS=I+MAXS
         V(IMAXS)=CF(I)*SW
         DO 20 J=1,MAXS
         SMM(J,IMAXS)=C(J,I)*SW
   20    SMM(IMAXS,J)=SMM(J,IMAXS)
      END IF
      SKEW=DTSLIN(MAXS+MAXCON)
      OOM=SUMW/(NUM-MAXS+MAXCON)*(SCALE*SCALE)
*
*     Calculate the covariance matrix.
*
      DO 30 I=1,MAXS
      DO 30 J=1,MAXS
   30 SMM(I,J)=SMM(I,J)*OOM
*
*     Test on convergence.
*
      DO 40 I=1,MAXS
      X1=SQRT(SMM(I,I))*EPS
      IF(ABS(V(I)).GT.X1) GO TO 50
   40 CONTINUE
      IF(ICYCLE.EQ.NCYCLE) GO TO 50
      ICYCLE=NCYCLE-1
      FORCED=.TRUE.
*
*     Print correlation matrix.
*
   50 IF(LMAT.NE.1.OR.ICYCLE.NE.NCYCLE) GO TO 90
      WRITE(6,1000)
      IA=1
      LIMIT=MAXS
   60 IF((LIMIT-IA+1).GT.20) LIMIT=IA+19
      WRITE(6,1001) (I,I=IA,LIMIT)
      DO 80 I=1,MAXS
      L=0
      X=SMM(I,I)
      DO 70 J=IA,LIMIT
      L=L+1
      Y=SMM(J,J)*X
   70 KS(L)=100*SMM(I,J)/(SQRT(ABS(Y))*SIGN(1.,Y))+0.5
   80 WRITE(6,1002) I,(KS(J),J=1,L)
      IF(LIMIT.GE.MAXS) GO TO 90
      IA=LIMIT+1
      LIMIT=MAXS
      GO TO 60
   90 RETURN
 1000 FORMAT('0CORRELATION MATRIX=')
 1001 FORMAT('0',4X,20I6)
 1002 FORMAT(I5,20I6)
      END
